unit funcoes;

interface

uses forms, IniFiles, windows, SysUtils, Controls, StdCtrls, Mask, Graphics, DBCtrls, ComCtrls, db, sqlexpr, Classes, ZAbstractRODataset, ZSqlMetadata, ZConnection, ZAbstractDataset, ZDataset, Registry, dialogs, UCBase, DateUtils,
  Printers, Messages, WinSock, ShellAPI, ShlObj, cxGridDBTableView, Grids, ComObj, Variants, ActiveX, IdMessage, IdTCPConnection, IdTCPClient,
  IdMessageClient, IdSMTP, IdBaseComponent, IdComponent, IdIOHandler,
  IdIOHandlerSocket, IdSSLOpenSSL, Math;

const

  EWX_LOGOFF = 0; // D "logoff" no usurio atual

  EWX_SHUTDOWN = 1; // "Shutdown" padro do sistema

  EWX_REBOOT = 2; // D "reboot" no equipamento

  EWX_FORCE = 4; // Fora o trmino dos processos

  EWX_POWEROFF = 8; // Desliga o equipamento

// constantes para mscaras de documentos
  CPF_MASK_DS = '000\.000\.000\-00;1; ';
  CPF_MASK_NS = '000\.000\.000\-00;0; ';
  RG_MASK_DS = '00\.000\.000\-0;1; ';
  RG_MASK_NS = '00\.000\.000\-0;0; ';
  REG_PROF_MASK_DS = '0000\/>L;1; ';
  REG_PROF_MASK_NS = '0000\/>L;0; ';
function ProcessArquivo(const Origem, Destino : string; Operacao, Modo:Integer) : Boolean;
function TiraTraco(valor: string): String;
function TiraEcomercial(Texto: string): string;
function TiraExtensao(S: string): string;
function MesExtenso(Month: Word): string;
procedure CorEntrada(Sender: TObject);
procedure CorSaida(Sender: TObject);
procedure DesligaWindows;
function TrataCampo(aNome: string): string;
procedure Alerta(mensagem: string); overload;
procedure Alerta(mensagem, Caption: string); overload;
procedure Erro(mensagem: string); overload;
procedure Erro(mensagem, Caption: string); overload;
function Pergunta(mensagem: string): boolean; overload;
function Pergunta(mensagem, Caption: string): boolean; overload;
procedure Aviso(mensagem: string); overload;
procedure Aviso(mensagem, Caption: string); overload;
function Space(N: integer): string;

function substrall(texto: string; ColIni: integer; Tamanho: integer): string;
function TiraPonto(aValor: string): string;
function TabelaTempDBexpress(SQL: string; BancoDados: TSQLConnection): string;
function TabelaTempZeos(SQL: string; BancoDados: TZConnection): string;
function TabelaTempZeosFireBird(SQL: string; BancoDados: TZConnection): string;
function TabelaExiste(NomeTabela: string; BancoDados: TZConnection): Boolean;
procedure ExecuteSQL(SQL: string; BancoDados: TZConnection);
function UltimoDiaMes(Data: TDateTime): Word;
function ValidarData(Data: string): Boolean;
function StrZero(const I: integer; const Casas: byte): string;
function GerarCodigo(nNumero: INT64): INT64;
function EOM(Data: TDateTime): TDateTime;
function VirgulaPorPonto(Numero: string): string;
function DataSistema(): TDateTime;
function ExtCem(pCem: string): string;
function Extenso(pValor: Extended): string;
function NumeroExtenso(pValor: Extended): string;
function StrZerof(const I: real; const Casas: byte): string;
function ian13(nNumero: int64): int64;
function ValidaQuebrado(CaixaTexto: TEdit): Boolean;
function TiraUnderline(Texto: string): string;
function ColocaUnderline(Texto: string): string;
function DiaExtenso2(dData: TDateTime): string;
function DiaExtenso(dData: TDateTime): string;
function PrimeiraLetraMaiscula(Texto: string): string;
function PrimeiraLetraMinuscula(Texto: string): string;
function SenhaM(Usuario: string; Modulo: string; Senha: string; var BancoDados: TZConnection; var user: Tusercontrol): boolean;
function Dia(Data: TDateTime): Integer;
function Mes(Data: TDateTime): Integer;
function Ano(Data: TDateTime): Integer;
function StrZeroff(const I: double; const Casas: byte; const decimal: byte): string;
function TiraLetra(const Palavra: string; const lista: string): string;
function substralll(const Palavra: string; const ColunaInicial: byte; const Tamanho: byte): string;
function substrallr(const Palavra: string; const ColunaInicial: byte; const Tamanho: byte): string;
function DataTexto(data: TdateTime): string;
function iif(ValorAtual, ValorComparar, ResultadoVerdadeiro, ResultadoFalso: Variant): Variant;
procedure ImpressoraPadrao(APrinterIndex: Integer);
function GetDefaultPrinterName: string;
procedure SetaImpressora(nomeImp: string);
function BDTemp(bd: TZConnection): TZConnection;
function ValidaQuebrado2(Sender: TObject; var Key: Char): Char;
function transform(nValor: real; cMasck: string): string;
function ExitWindowsEx98(uFlags: integer; dwReserved: word): boolean; external 'user32.dll' name 'ExitWindowsEx';
function GetDataSistema(const FileName: string): TDateTime;
function RetornaIndiceColuna(StrNomeColuna: string; GridTab: TcxGridDBTableView): integer;
function ValorToTexto(Valor: Double): string;
function CampoExiste(tabela:string; campo:string; BancoDados:TZConnection): Boolean;
function ArredontaFloat(x : Real): Real;
function VerificaNumero(palavra : string): Boolean;
function TiraVirgula(aValor: string): string;
function ProcuraStringNoArquivo(Palavra : String; NomeDoArquivo : string): TStringList;
function ExecAndWait(const FileName, Params: string; const WindowState: Word): boolean;
function ExcelToStringGrid(AGrid: TStringGrid; AXLSFile: string): Boolean;
//function abcd(letra : string): Integer;
 function UFToInt(pUF: String): Integer;
{Funcao de um dll do windows}
function BlockInput(fbLookIt: Boolean): Integer; stdcall; external 'user32.dll';

function GetVersaoWindows: string;
function MaxCampo(NomeCampo: string; NomeTabela: string; ConexaoBancoDados: TZConnection): Integer;
function Replicate(Texto: string; QTD: integer): string;
function TextoAEsquerda(Texto: string; TamanhoString: Integer): string;
function TextoADireita(Texto: string; TamanhoString: Integer): string;
function TextoAoCentro(Texto: string; TamanhoString: Integer): string;
function GetBuildInfo: string;
function GetIP: string;
function MouseShowCursor(const Show: boolean): boolean;
function BrowseDialogCallBack(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): integer stdcall;
function BrowseDialog(const Title: string; const Flag: integer): string;
function ListarArquivos(ListaRetorno: TStrings; DiretorioInicial: string; Mascara: string; RetornarCaminho: Boolean = False; ProcurarEmSubDiretorios: Boolean = False): TStrings;
procedure TratarErro(Sender: TObject; E: Exception);
function GetSystemPath(): string;
function TabelaExisteZeosPG(NomeTabela: string; ConexaoBancoDados: TZConnection): Boolean;
function SequenciaExisteZeosPG(NomeSequencia: string; ConexaoBancoDados: TZConnection): Boolean;
function TabelaTempZeosPG(EstruturaTabela: string; ConexaoBancoDados: TZConnection): string;
procedure GetTableNamesZeosPG(ListaTabelas: TStringList; ConexaoBancoDados: TZConnection);
function GetVariantType(const v: variant): string;
procedure ExportaTabelaArquivoTextoZeosPG(NomeArquivo: string; Tabela: TZQuery);
procedure ImportaArquivoTextoTabelaZeosPG(NomeArquivo: string; NomeTabela: string; ConexaoBancoDados: TZConnection);
function GetWindowsTemp(): string;
function RetirarCaracteres(Texto: string; CaracteresRetirar: string): string;
function ValidaCPF(NumeroCPF: string): Boolean;
function ValidaCGC(NumeroCGC: string): Boolean;
function MemoriaEmUso(): Cardinal;
function QtdDiasUteis(DataIni, DataFim: TDate): Integer;
function QtdDiasPeriodo(DataIni, DataFim: TDate; DiasSemana: string = '1234567'): Integer;
function RetornaTipoCampoTabela(Tabela: TZQuery; NomeCampo: string): string;
function PerguntaCancelar(mensagem: string): integer;
function TrocaVigulaPonto(Texto: string): string;
function DataAmericana(Data: TDateTime): string;
function RoundCustom(Valor_Inicial: Double; Valor_Arredondar: Double): Double;
function TiraZeroEsquerda(Valor : string) : string;
function BuscaTroca(Text,Busca,Troca : string) : string;
function SetGlobalEnvironment(const Name, Value: string; const User: Boolean = True): Boolean;
function tbGetEnvVar(const VarName: string): string;
function Coalesce(Value1: Variant; Value2: Variant): Variant; overload;
function Truncar(pValor: Double; pCasasDecimais:Integer=2;pTruncar: Boolean=true): double;

//Extenso Nota Fiscal Paulista
function RetornaNumNFP(numero : Integer): string;
function StrIsInteger(const S: string): boolean;
function NumeroOuLetra(Palavra:String; Tamanho:Integer) : string;
function TiraNulo(Palavra : string): string;
function TiraEnter(Palavra : string): string;
procedure AtalhoParaDesktop(FileName:string; Caption: widestring);
function IncrementaValor(value : Integer) : Integer;
function ConstraintExiste(NomeTabela, NomeConstraint : string; BancoDados: TZConnection):Boolean;
function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; Tamanho, TamanhoScale : Double; BancoDados: TZConnection): Boolean; overload;
function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; BancoDados: TZConnection): Boolean; overload;
function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; Tamanho : Double; BancoDados: TZConnection): Boolean; overload;
 //Pega Serial do HD
Function SerialNumHD(FDrive:String) :String;
//GEra Serial de Licensa do SAC
function GeraSerial2(Name:string):string;
 //Retornar Somente os nmeros de uma String
function RetornaSomenteNumeros(const S: string): string;
function IsAphaNumerico(S : string) : Boolean;
function VerificaLicencaSistema(pBancoDados : TZConnection) : Boolean;

implementation

function IncrementaValor(value : Integer) : Integer;
begin
  Result := value + 1;
end;

function DataAmericana(Data: TDateTime): string;
var
  iDia, iMes, iAno: Integer;
begin
  iDia := Dia(Data);
  iMes := Mes(Data);
  iAno := Ano(Data);
  Result := strzero(iMes, 2) + FormatSettings.DateSeparator + strzero(iDia, 2) + FormatSettings.DateSeparator + strzero(iAno, 4);
end;

function TrocaVigulaPonto(Texto: string): string;
var
  i: integer;
  aux: string;
begin
  aux := '';
  for i := 1 to length(Texto) do
  begin
    if texto[i] = ',' then
    begin
      aux := aux + '.';
    end
    else
    begin
      aux := aux + texto[i];
    end;
  end;
  result := aux;
end;

function MesExtenso(Month: Word): string;
const
  MonthStr: array[1..12] of string[9] = ('Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembro', 'Dezembro');
begin
  MesExtenso := MonthStr[Month]
end;

procedure CorEntrada(Sender: TObject);
begin
  if (Sender is TEdit) then
    (Sender as TEdit).Color := clBlue

  else if (Sender is TMaskEdit) then
    (Sender as TMaskEdit).Color := clBlue
  else if (Sender is TMemo) then
    (Sender as TMemo).Color := clBlue
  else if (Sender is TDBEdit) then
    (Sender as TDBEdit).Color := clBlue
  else if (Sender is TDBMemo) then
    (Sender as TDBMemo).Color := clBlue
  else if (Sender is TCombobox) then
    (Sender as TCombobox).Color := clBlue
  else if (Sender is TComboboxex) then
    (Sender as TComboboxEx).Color := clBlue;
end;

procedure CorSaida(Sender: TObject);
begin
  if (Sender is TEdit) then
    (Sender as TEdit).Color := clWindow
  else if (Sender is TMaskEdit) then
    (Sender as TMaskEdit).Color := clWindow
  else if (Sender is TMemo) then
    (Sender as TMemo).Color := clWindow
  else if (Sender is TDBEdit) then
    (Sender as TDBEdit).Color := clWindow
  else if (Sender is TDBMemo) then
    (Sender as TDBMemo).Color := clWindow
  else if (Sender is TCombobox) then
    (Sender as TCombobox).Color := clWindow
  else if (Sender is TComboboxex) then
    (Sender as TComboboxEx).Color := clWindow;
end;

function TrataCampo(aNome: string): string;
var
  i, Tam: integer;
  aux, semEspaco: string;
  nFlag: boolean;
begin
  semEspaco := trim(aNome);
  Tam := Length(semEspaco);
  aux := '';
  nFlag := false;
  for i := 1 to Tam do
  begin
    if i = 1 then
    begin
      aux := UpperCase(semEspaco[i]);
    end
    else
    begin
      if semEspaco[i] = '_' then
      begin
        aux := aux + ' ';
        nFlag := true;
      end
      else
      begin
        if nFlag then
        begin
          aux := aux + UpperCase(semEspaco[i]);
          nFlag := false;
        end
        else
          aux := aux + lowerCase(semEspaco[i])
      end;
    end
  end;
  TrataCampo := aux;
end;

procedure alerta(mensagem: string);
begin
  application.MessageBox(Pchar(mensagem), 'Ateno', mb_iconExclamation);
end;

procedure Alerta(mensagem, Caption: string);
begin
  Application.MessageBox(PChar(mensagem), PChar(Caption), MB_ICONEXCLAMATION);
end;

procedure aviso(mensagem: string);
begin
  application.MessageBox(Pchar(mensagem), 'Aviso', mb_iconInformation);
end;

procedure Aviso(mensagem, Caption: string);
begin
  Application.MessageBox(PChar(mensagem), PChar(Caption), MB_ICONINFORMATION);
end;

procedure erro(mensagem: string);
begin
  application.MessageBox(Pchar(mensagem), 'Erro', mb_iconError);
end;

procedure Erro(mensagem, Caption: string);
begin
  Application.MessageBox(PChar(mensagem), PChar(Caption), MB_ICONERROR)
end;

function pergunta(mensagem: string): boolean;
begin
  if application.MessageBox(Pchar(mensagem), 'Pergunta', mb_iconquestion + mb_yesNo) = idNo then
    result := false
  else
    result := true;
end;

function Pergunta(mensagem, Caption: string): boolean;
begin
  if Application.MessageBox(Pchar(mensagem), PChar(Caption), mb_iconquestion + mb_yesNo) = idNo then
    result := false
  else
    result := true;
end;

function PerguntaCancelar(mensagem: string): integer;
begin
  result := application.MessageBox(Pchar(mensagem), 'Pergunta', mb_iconquestion + mb_yesNoCancel);
end;

function Space(N: integer): string;
var
  i: integer;
  s: string;
begin
  s := '';
  for i := 1 to N do
    s := s + ' ';
  Result := s;
end;

function substrall(texto: string; ColIni: integer; Tamanho: integer): string;
var
  cRetorno: string;
begin
  cRetorno := trim(texto);
  cRetorno := copy(Texto, ColIni, Tamanho);
  cRetorno := cRetorno + space(Tamanho - length(cRetorno));
  if cRetorno = '' then
    cRetorno := space(Tamanho);

  result := cRetorno;
end;

function TiraPonto(aValor: string): string;
var
  aux: string;
  i: integer;
begin
  aux := '';
  for i := 1 to length(aValor) do
    if aValor[i] <> FormatSettings.ThousandSeparator then
      aux := aux + aValor[i];
  result := aux;
end;

function TiraVirgula(aValor: string): string;
var
  aux: string;
  i: integer;
begin
  aux := '';
  for i := 1 to length(aValor) do
    if aValor[i] <> FormatSettings.ThousandSeparator then
      aux := aux + aValor[i];
  result := aux;
end;

function TabelaTempDBexpress(SQL: string; BancoDados: TSQLConnection): string;
var
  i, j: integer;
  listaTab: TstringList;
  NomeTab: string;
  existTab: boolean;
begin
  result := '';
  for j := 1 to 200 do
  begin
    NomeTab := 'temp' + trim(inttostr(j));
    ////Pesquisa se a tabelaExiste
    listaTab := TStringList.Create;
    bancodados.GetTableNames(listatab, false);
    existTab := true;
    for i := 0 to listatab.Count - 1 do
    begin
      if listaTab.Strings[i] = nomeTab then
      begin
        existTab := true;
        break;
      end
      else
        existTab := false;
    end;
    if not existTab then
      break;
  end;
  bancodados.ExecuteDirect('create table ' + nomeTab + ' ' + sql);
  result := nomeTab;
end;

function TabelaExiste(NomeTabela: string; BancoDados: TZConnection): Boolean;
var
  ZSQLMetadata: TZSQLMetadata;
begin
  BancoDados.Disconnect;
  BancoDados.Connect;
  ZSQLMetadata := TZSQLMetadata.Create(nil);
  ZSQLMetadata.Connection := BancoDados;
  ZSQLMetadata.MetadataType := mdTables;
  ZSQLMetaData.Open;
  ZSQLMetadata.Active := True;
  if (ZSQLMetadata.Locate('table_name', NomeTabela, [loCaseInsensitive])) and (ZSQLMetadata.FieldValues['table_type'] = 'TABLE') then
  begin
    TabelaExiste := True;
  end
  else
  begin
    TabelaExiste := False;
  end;
  ZSQLMetadata.Close;
  ZSQLMetadata.Free;
end;

function TabelaTempZeos(SQL: string; BancoDados: TZConnection): string;
var
  j: Integer;
  NomeTab: string;
begin
  BancoDados.Disconnect;
  BancoDados.Connect;
  Result := '';
  NomeTab := '';
  for j := 1 to 500 do
  begin
    NomeTab := 'temp' + Trim(IntToStr(j));
    ////Pesquisa se a tabelaExiste
    if not TabelaExiste(nomeTab, BancoDados) then
      break;
  end;
  ExecuteSQL('create table ' + NomeTab + ' ' + SQL, BancoDados);
  Result := NomeTab;
end;

function TabelaTempZeosFireBird(SQL: string; BancoDados: TZConnection): string;
var
  fQuery: TZQuery;
  x: Integer;
  NomeTabelaTemp: string;
begin
  fQuery := TZQuery.Create(nil);
  try
    fQuery.Connection := BancoDados;
    fQuery.SQL.Clear;
    fQuery.SQL.Add('Select (rdb$relation_name) as nome_tabela from rdb$relations where ((rdb$system_flag=0) or (rdb$system_flag is null)) and (rdb$view_source is null) order by rdb$relation_name');
    fQuery.Open;

    x := 0;
    repeat
      Inc(x);
      NomeTabelaTemp := UpperCase('temp' + IntToStr(x));
    until not fQuery.Locate('nome_tabela', NomeTabelaTemp, [loCaseInsensitive]);

    ExecuteSQL('create table ' + NomeTabelaTemp + ' ' + SQL, BancoDados);

    Result := NomeTabelaTemp;

    fQuery.Close;
  finally
    fQuery.Free;
  end;
end;

procedure ExecuteSQL(SQL: string; BancoDados: TZConnection);
var
  SqlQuery: TZQuery;
begin
  SqlQuery := TZQuery.Create(nil);
  try
    SqlQuery.Connection := BancoDados;
    SqlQuery.SQL.Clear;
    SqlQuery.SQL.Add(SQL);
    SqlQuery.ExecSQL;
    SqlQuery.Close;
  finally
    SqlQuery.Free;
  end;
end;

function UltimoDiaMes(Data: TDateTime): Word;
var
  Dia, Mes, Ano: Word;
  DT: TDateTime;
begin
  DecodeDate(Data, Ano, Mes, Dia);
  Inc(Mes);
  if Mes = 13 then
  begin
    Mes := 1;
  end;
  DT := EncodeDate(Ano, Mes, 1);
  DT := DT - 1;
  DecodeDate(DT, Ano, Mes, Dia);
  Result := Dia;
end;

function ValidarData(Data: string): Boolean;
begin
  Result := true;
  try
    StrToDate(Data);
  except on EConvertError do
      Result := False;
  end;
end;

function StrZero(const I: integer; const Casas: byte): string;
var
  Ch: Char;
begin
  Result := IntToStr(I);
  if Length(Result) > Casas then
  begin
    Ch := '*';
    Result := '';
  end
  else
    Ch := '0';
  while Length(Result) < Casas do
    Result := Ch + Result;
end;

function StrZerof(const I: real; const Casas: byte): string;
var
  Ch: Char;
  aux: string;
  aux1: string;
  //  posicao : integer;
begin
  aux := floatToStrF(I, ffFixed, 14, 2);
  //  posicao := pos(aux,',');
  //  if Posicao = length(aux)-2 then
  //   aux := aux+'0';
  aux := copy(aux, 1, length(aux) - 3);
  aux1 := copy(floatToStrF(I, ffFixed, 14, 2), length(trim(floatToStrF(I, ffFixed, 14, 2))) - 2, 3);
  Result := aux;
  if Length(Result) > Casas - 3 then
  begin
    Ch := '*';
    Result := '';
  end
  else
    Ch := '0';
  while Length(Result) < Casas - 3 do
    Result := Ch + Result;
  result := result + trim(aux1);
end;

function GerarCodigo(nNumero: INT64): INT64;
var
  aux: string;
  nLanc: integer;
  dataAux: TDateTime;
  dia, mes, ano: word;
  strDia, strMes, strAno, soma: string;
begin
  if nNumero <> 0 then
  begin
    aux := trim(intTostr(nNumero));
    strAno := copy(aux, 1, 4);
    strMes := copy(aux, 5, 2);
    strDia := copy(aux, 7, 2);
    soma := trim(strDia + '/' + strmes + '/' + strAno);
    dataAux := strtodate(soma);
    if dataAux <> date then
      nLanc := 0
    else
      nLanc := strtoInt(copy(aux, 9, 4));
  end
  else
  begin
    nLanc := 0;
  end;
  /////Retorna o numero
  DecodeDate(date, Ano, Mes, Dia);

  result := strToint64(intTostr(ano) + strzero(mes, 2) + strZero(dia, 2) + strzero(nLanc + 1, 4));
end;

function VirgulaPorPonto(Numero: string): string;
var
  NumeroT: string;
  x: Integer;
begin
  NumeroT := '';
  for x := 1 to Length(Numero) do
  begin
    if Copy(Numero, x, 1) = ',' then
    begin
      NumeroT := NumeroT + '.';
    end
    else
    begin
      NumeroT := NumeroT + Copy(Numero, x, 1);
    end;
  end;
  Result := NumeroT;
end;

function DataSistema(): TDateTime;
var
  Reg: TRegistry;
begin
  Reg := TRegistry.Create;
  try
    { Define a chave-raiz do registro }
    Reg.RootKey := HKEY_CURRENT_USER;
    { Abre chave (path). }
    Reg.OpenKey('System\Computer\Files', false);
    Result := Reg.ReadDate('DES');
  finally
    Reg.Free;
  end;
end;

function Truncar(pValor: Double; pCasasDecimais:Integer=2;pTruncar: Boolean=true): double;
var
fator : Extended;
begin
  fator := Power(10,pCasasDecimais);
  pValor := (fator * pValor);
  if pTruncar
  then pValor := Trunc(pValor)
  else pValor := Round(pValor);

  Result := (pValor * (1/fator));
end;



function Extenso(pValor: Extended): string;
const
  aCifra: array[1..6, 1..2] of string = (('TRILHO,', 'TRILHOES,'),
    ('BILHAO,', 'BILHES,'),
    ('MILHAO,', 'MILHES,'),
    ('MIL,', 'MIL,'),
    (' ', ' '),
    ('CENTAVO', 'CENTAVOS'));
var
  tStr, tExtenso, tSubs: string;
  tX, tCentavos, aux, x: Integer;
  straux1, straux2: string;
  Ext: string;
begin
  tSubs := ' ';
  tExtenso := ' ';
  tStr := StrZerof(pValor, 18);
  tCentavos := StrToInt(Copy(tStr, 17, 2));
  if pValor > 0 then
  begin
    if tCentavos > 0 then
    begin
      if tcentavos = 1 then
        aux := 1
      else
        aux := 2;
      tExtenso := ExtCem(StrZero(tCentavos, 3)) + aCifra[6, Trunc(aux)];
    end;
    if trunc(pValor) > 0 then
    begin
      if trunc(pValor) = 1 then
        strAux1 := ' REAL'
      else
        strAux1 := ' REAIS';

      if tCentavos > 0 then
        strAux2 := ' E '
      else
        strAux2 := '';

      tExtenso := straux1 + straux2 + tExtenso;
    end;
    for tX := 5 downto 1 do
    begin
      tSubs := Copy(tStr, (tX * 3) - 2, 3);
      if StrToInt(tSubs) > 0 then
      begin
        if StrToInt(tSubs) = 1 then
          aux := 1
        else
          aux := 2;
        tExtenso := ExtCem(tSubs) + aCifra[tX, Trunc(aux)] + ' ' + tExtenso;
      end;
    end;
  end;
  Result := tExtenso;

  {
    Ext := Trim(tExtenso);
    x := 1;
    tExtenso := '';
    while x <= Length(Ext) do begin
      if (Copy(Ext, x, 1) = ' ') or (x >= Length(Ext)) then begin
        tExtenso := Trim(tExtenso + ' ' + Copy(Ext, 1, x));
        Ext := Trim(Copy(Ext, x + 1, Length(Ext)));
        x := 0;
      end;
      Inc(x);
    end;
  }
  Ext := ' ' + LowerCase(Trim(tExtenso));
  x := 1;
  tExtenso := '';
  while x <= Length(Ext) do
  begin
    if (Copy(Ext, x, 1) = ' ') or (x >= Length(Ext)) then
    begin
      tExtenso := Trim(tExtenso + ' ' + UpperCase(Copy(Ext, 1, 1)) + Copy(Ext, 2, x - 1));
      Ext := Trim(Copy(Ext, x + 1, Length(Ext)));
      x := 0;
    end;
    Inc(x);
  end;

  Result := Trim(tExtenso);
end;

function ExtCem(pCem: string): string;
const
  aCent: array[1..9] of string =
  ('CENTO', 'DUZENTOS', 'TREZENTOS', 'QUATROCENTOS', 'QUINHENTOS', 'SEISCENTOS'
    , 'SETECENTOS', 'OITOCENTOS', 'NOVECENTOS');
  aVint: array[1..9] of string =
  ('ONZE', 'DOZE', 'TREZE', 'QUATORZE', 'QUINZE', 'DEZESSEIS', 'DEZESSETE', 'DEZOITO', 'DEZENOVE');
  aDez: array[1..9] of string =
  ('DEZ', 'VINTE', 'TRINTA', 'QUARENTA', 'CINQUENTA', 'SESSENTA', 'SETENTA', 'OITENTA', 'NOVENTA');
  aUnit: array[1..9] of string =
  ('UM', 'DOIS', 'TRES', 'QUATRO', 'CINCO', 'SEIS', 'SETE', 'OITO', 'NOVE');
var
  aVal: array[1..3] of integer;
  text, strAux: string;
begin
  text := '';
  aVal[1] := StrToInt(Copy(pCem, 1, 1));
  aVal[2] := StrToInt(Copy(pCem, 2, 1));
  aVal[3] := StrToInt(Copy(pCem, 3, 1));
  if StrToInt(pCem) > 0 then
  begin
    if StrToInt(pCem) = 100 then
      text := 'CEM'
    else
    begin
      if aVal[1] > 0 then
      begin
        if (aVal[2] + aVal[3]) > 0 then
          strAux := ' E '
        else
          strAux := ' ';
        text := aCent[aVal[1]] + straux;
      end;
      if (aVal[2] = 1) and (aVal[3] > 0) then
        text := text + ' ' + aVint[Aval[3]]
      else
      begin
        if aVal[2] > 0 then
        begin
          if aVal[3] > 0 then
            strAux := ' E '
          else
            strAux := ' ';
          text := text + ' ' + aDez[aVal[2]] + straux;
        end;
        if aVal[3] > 0 then
          strAux := ' ' + aUnit[aVal[3]]
        else
          strAux := ' ';
        text := text + strAux;
      end;
    end;
  end;
  text := text + ' ';
  Result := text;
end;

function NumeroExtenso(pValor: Extended): string;
const
  aCifra: array[1..5, 1..2] of string = (('TRILHO,', 'TRILHOES,'),
    ('BILHAO,', 'BILHES,'),
    ('MILHAO,', 'MILHES,'),
    ('MIL,', 'MIL,'),
    (' ', ' '));
var
  tStr, tExtenso, tSubs: string;
  tX, tCentavos, aux, x: Integer;
  straux1, straux2: string;
  Ext: string;
begin
  tSubs := ' ';
  tExtenso := ' ';
  tStr := StrZerof(pValor, 18);
  tCentavos := StrToInt(Copy(tStr, 17, 2));
  if pValor > 0 then
  begin
    if tCentavos > 0 then
    begin
      if tcentavos = 1 then
        aux := 1
      else
        aux := 2;
      tExtenso := ExtCem(StrZero(tCentavos, 3)) ;
    end;
    if trunc(pValor) > 0 then
    begin
      if tCentavos > 0 then
        strAux2 := ' e '
      else
        strAux2 := '';

      tExtenso := straux1 + straux2 + tExtenso;
    end;
    for tX := 5 downto 1 do
    begin
      tSubs := Copy(tStr, (tX * 3) - 2, 3);
      if StrToInt(tSubs) > 0 then
      begin
        if StrToInt(tSubs) = 1 then
          aux := 1
        else
          aux := 2;
        tExtenso := ExtCem(tSubs) + aCifra[tX, Trunc(aux)] + ' ' + tExtenso;
      end;
    end;
  end;
  Result := tExtenso;

  Ext := ' ' + LowerCase(Trim(tExtenso));
  x := 1;
  tExtenso := '';
  while x <= Length(Ext) do
  begin
    if ((Copy(Ext, x, 1) = ' ') or (x >= Length(Ext))) then
    begin
      if (Copy(Ext, 1, 2) = 'e ') then
        tExtenso := Trim(tExtenso + ' ' + LowerCase(Copy(Ext, 1, 1)) + Copy(Ext, 2, x - 1))
      else
        tExtenso := Trim(tExtenso + ' ' + UpperCase(Copy(Ext, 1, 1)) + Copy(Ext, 2, x - 1));
      Ext := Trim(Copy(Ext, x + 1, Length(Ext)));
      x := 0;
    end;
    Inc(x);
  end;

  Result := Trim(tExtenso);
end;

function ian13(nNumero: int64): int64;
var
  aMult: array[1..12] of integer;
  i: integer;
  nResultado: int64;
begin
  ////incializa o vetor com valores
  aMult[1] := 1;
  aMult[2] := 3;
  aMult[3] := 1;
  aMult[4] := 3;
  aMult[5] := 1;
  aMult[6] := 3;
  aMult[7] := 1;
  aMult[8] := 3;
  aMult[9] := 1;
  aMult[10] := 3;
  aMult[11] := 1;
  aMult[12] := 3;
  nResultado := 0;
  for i := 12 downto 1 do
    nResultado := nResultado + strToint(copy(intTostr(nNumero), i, 1)) * aMult[i];
  if copy(strzero(nResultado, 3), 3, 1) = '0' then
    nResultado := strToint64(trim(intTostr(nNumero)) + '0')
  else
    nResultado := strToint64(trim(intTostr(nNumero)) + trim(intTostr((10 - strToint(copy(trim(intTostr(nResultado)), length(trim(intTostr(nResultado))), 1))))));
  result := nResultado;
end;

function ValidaQuebrado(CaixaTexto: TEdit): Boolean;
var
  x: integer;
  texto: string;
begin
  Result := True;
  texto := CaixaTexto.Text;
  //verifca se a caixa de texto est vazia
  //se estiver nao deixa digitar a virgula
  if trim(texto) = '' then
  begin
    Result := False;
    exit;
    //verificar se a posicao do cursor esta no comeo
    //se estiver nao deixa digitar a virgula
  end
  else if CaixaTexto.SelStart = 0 then
  begin
    Result := False;
    exit;
  end;
  //verifica se ja tem uma virgula na caixa de texto
  //se tiver nao deixa digitar a virgula
  for x := 0 to length(CaixaTexto.Text) do
  begin
    if texto[x] = ',' then
    begin
      Result := False;
      break;
    end;
  end;
end;

function TiraUnderline(Texto: string): string;
var
  x: integer;
  TextoTratado: string;
begin
  TextoTratado := '';
  for x := 1 to Length(Texto) do
  begin
    if Copy(Texto, x, 1) <> '_' then
    begin
      TextoTratado := TextoTratado + Copy(Texto, x, 1);
    end
    else
    begin
      TextoTratado := TextoTratado + ' ';
    end;
  end;
  Result := TextoTratado;
end;

function ColocaUnderline(Texto: string): string;
var
  x: integer;
  TextoTratado: string;
begin
  TextoTratado := '';
  for x := 1 to Length(Texto) do
  begin
    if Copy(Texto, x, 1) <> ' ' then
    begin
      TextoTratado := TextoTratado + Copy(Texto, x, 1);
    end
    else
    begin
      TextoTratado := TextoTratado + '_';
    end;
  end;
  Result := TextoTratado;
end;

function PrimeiraLetraMaiscula(Texto: string): string;
var
  x: Integer;
  LM: Integer;
  TextoTratado: string;
begin
  LM := 1;
  TextoTratado := '';
  for x := 1 to Length(Texto) do
  begin
    if LM = 1 then
    begin
      TextoTratado := TextoTratado + UpperCase(Copy(Texto, x, 1));
      LM := 0;
    end
    else
    begin
      TextoTratado := TextoTratado + Copy(LowerCase(Texto), x, 1);
    end;
    if Copy(Texto, x, 1) = ' ' then
    begin
      LM := 1
    end;
  end;
  Result := TextoTratado;
end;

function PrimeiraLetraMinuscula(Texto: string): string;
var
  x: Integer;
  LM: Integer;
  TextoTratado: string;
begin
  LM := 1;
  TextoTratado := '';
  for x := 1 to Length(Texto) do
  begin
    if LM = 1 then
    begin
      TextoTratado := TextoTratado + LowerCase(Copy(Texto, x, 1));
      LM := 0;
    end
    else
    begin
      TextoTratado := TextoTratado + Copy(Texto, x, 1);
    end;
    if Copy(Texto, x, 1) = ' ' then
    begin
      LM := 1
    end;
  end;
  Result := TextoTratado;
end;

function SenhaM(Usuario: string; Modulo: string; Senha: string; var BancoDados: TZConnection; var user: TUserControl): boolean;
var
  SenhaMestre, Veri: TZQuery;
  Retorno: boolean;
  CampoSenhaUsuario, SenhaUsuario, TabelaSenhas, CampoUsuario, AuxSenha, AuxComando: string;
begin
  try
    SenhaMestre := TzQuery.Create(nil);
    Veri := TzQuery.Create(nil);
    try
      SenhaMestre.Connection := Bancodados;
      SenhaMestre.SQL.Clear;
      SenhaMestre.SQL.Add('select * from senhamestre where usuario = :nUser');
      SenhaMestre.ParamByName('nUser').AsString := Usuario;
      SenhaMestre.Open;
      SenhaMestre.First;
      if SenhaMestre.RecordCount = 0 then
      begin
        result := false;
        exit;
      end;

      user.RetornaInfUsuarios(CampoUsuario, CampoSenhaUsuario, SenhaUsuario, TabelaSenhas, senha);

      AuxSenha := CampoSenhaUsuario + ' = ' + QuotedStr(SenhaUsuario);
      AuxComando := 'Select * from ' + TabelaSenhas + ' Where ' +
        CampoUsuario + ' = ' + QuotedStr(usuario) + ' and ' + AuxSenha;

      Veri.Connection := BancoDados;
      Veri.SQL.Clear;
      veri.SQL.Add(AuxComando);
      Veri.Open;
      if Veri.RecordCount = 0 then
      begin
        retorno := false;
      end
      else
      begin
        retorno := true;
      end;
      ///////com as informacoes retornadas, ser criado um query

     /// retorno := user.VerificaUsuario(usuario, senha);

      if retorno then
      begin
        if senhamestre.FieldByName(modulo).AsString = 'S' then
        begin
          result := true;
          exit;
        end;
      end;
      result := false;

      SenhaMestre.Close;
      Veri.Close;
    finally
      SenhaMestre.Free;
      Veri.Free;
    end;
  except
    result := false;
  end;
end;

function TiraEcomercial(Texto: string): string;
var
  i: integer;
  aux: string;
begin
  aux := '';
  for i := 1 to length(Texto) do
    if Texto[i] <> '&' then
      aux := aux + Texto[i];
  result := aux;
end;

function Dia(Data: TDateTime): Integer;
begin
  Result := DayOf(Data);
end;

function Mes(Data: TDateTime): Integer;
begin
  Result := MonthOf(Data);
end;

function Ano(Data: TDateTime): Integer;
begin
  Result := YearOf(Data);
end;

function StrZeroff(const I: double; const Casas: byte; const decimal: byte): string;
var
  Ch: Char;
  aux: string;
  aux1: string;
  normaliza: real;
begin
  normaliza := strtofloat(copy(floattostr(i), 1, casas));
  aux := trim(floatToStrF(normaliza, ffFixed, casas, decimal));
  aux1 := '';
  if pos(',', aux) > 0 then
  begin
    aux := copy(aux, 1, pos(',', aux) - 1);
    aux1 := copy(floatToStrF(normaliza, ffFixed, casas, decimal), pos(',', trim(floatToStrF(I, ffFixed, casas, decimal))) + 1, casas);
  end;
  Result := trim(aux) + trim(aux1);
  ch := '0';
  while Length(Result) < Casas do
    Result := Ch + Result;
  result := result
end;

function TiraLetra(const Palavra: string; const lista: string): string;
var
  aux: string;
  i: integer;
  lista1: TStringList;
begin
  lista1 := TStringList.Create;
  for i := 1 to length(lista) do
    lista1.Add(lista[i]);
  aux := '';
  for i := 1 to length(palavra) do
  begin
    if lista1.IndexOf(palavra[i]) < 0 then
    begin
      aux := aux + palavra[i];
    end;
  end;
  lista1.Free;
  result := aux;
end;

function substralll(const Palavra: string; const ColunaInicial: byte; const Tamanho: byte): string;
var
  Ch: Char;
  aux: string;
begin
  aux := trim(copy(palavra, colunainicial, tamanho));
  Result := aux;
  ch := ' ';
  while Length(Result) < Tamanho do
    Result := Ch + Result;
  result := result
end;

function substrallr(const Palavra: string; const ColunaInicial: byte; const Tamanho: byte): string;
var
  Ch: Char;
  aux: string;
begin
  aux := trim(copy(palavra, colunainicial, tamanho));
  Result := aux;
  ch := ' ';
  while Length(Result) < Tamanho do
    Result := Result + ch;
  result := result
end;

function DataTexto(data: TdateTime): string;
begin
  result := strzero(ano(data), 4) + strzero(mes(data), 2) + strzero(dia(data), 2);
end;

procedure ImpressoraPadrao(APrinterIndex: Integer);
var
  Device: array[0..255] of char;
  Driver: array[0..255] of char;
  Port: array[0..255] of char;
  hDeviceMode: THandle;
begin
  Printer.PrinterIndex := APrinterIndex;
  Printer.GetPrinter(Device, Driver, Port, hDeviceMode);
  StrCat(Device, ',');
  StrCat(Device, Driver);
  StrCat(Device, ',');
  StrCat(Device, Port);
  WriteProfileString('windows', 'device', Device);
  StrCopy(Device, 'windows');
  SendMessage(HWND_BROADCAST, WM_WININICHANGE, 0, longint(@Device));
end;
//////pega o nome da atual impressora padrao

function GetDefaultPrinterName: string;
//
// Retorna o nome da impressora padro do Windows
//
begin
  if (Printer.PrinterIndex > 0) then
    Result := Printer.Printers[Printer.PrinterIndex]
  else
    Result := 'Nenhuma impressora Padro foi detectada';
end;

procedure SetaImpressora(nomeImp: string);
begin
  if trim(GetDefaultPrinterName) <> trim(nomeImp) then ///muda para padrao somente se for diferente da impressora padrao atual
    ImpressoraPadrao(Printer.Printers.IndexOf(trim(nomeImp)));
end;

function BDTemp(bd: TZConnection): TZConnection;
var
  aux: TZConnection;
begin
  aux := TZConnection.Create(nil);
  aux.Database := bd.Database;
  aux.HostName := bd.HostName;
  aux.Protocol := bd.Protocol;
  aux.User := bd.User;
  aux.TransactIsolationLevel := bd.TransactIsolationLevel;
  aux.Connect;
  result := aux;
end;

function ValidaQuebrado2(Sender: TObject; var Key: Char): Char;
var
  x: integer;
  Texto: string;
begin
  //se a tecla nao for igual a:
  // 0 ou 1 ou 2 ou 3 ou 4 ou 5 ou 6 ou 7 ou 8 ou 9 ou - ou . ou , ou BackSpace
  //nao permite a tecla
  Result := #0;
  if not (Key in ['0'..'9', '-', '.', ',', #8]) then
  begin
    Exit;
  end;
  //se a tecla nao for igual a:
  // 0 ou 1 ou 2 ou 3 ou 4 ou 5 ou 6 ou 7 ou 8 ou 9 ou BackSpace
  //validar se permite
  if not (Key in ['0'..'9', #8]) then
  begin
    if TComponent(Sender) is TEdit then
    begin
      Texto := TEdit(Sender).Text;
    end
    else if TComponent(Sender) is TDBEdit then
    begin
      Texto := TDBEdit(Sender).Text;
    end
    else
    begin
      Texto := '';
    end;
    //ser for pressionado -
    if Key = '-' then
    begin
      if TComponent(Sender) is TEdit then
      begin
        if TEdit(Sender).SelStart > 0 then
        begin
          Exit;
        end;
      end
      else if TComponent(Sender) is TDBEdit then
      begin
        if TDBEdit(Sender).SelStart > 0 then
        begin
          Exit;
        end;
      end;
      for x := 0 to length(Texto) do
      begin
        if Copy(Texto, x, 1) = '-' then
        begin
          Exit;
          Break;
        end;
      end;
      //ser for pressionado . ou ,
    end
    else if (key = '.') or (key = ',') then
    begin
      Key := FormatSettings.DecimalSeparator;
      //verifca se a caixa de texto est vazia
      if Trim(Texto) = '' then
      begin
        if TComponent(Sender) is TEdit then
        begin
          TEdit(Sender).Text := '0' + FormatSettings.DecimalSeparator;
          TEdit(Sender).SelStart := Length(TEdit(Sender).Text);
        end
        else if TComponent(Sender) is TDBEdit then
        begin
          TDBEdit(Sender).Text := '0' + FormatSettings.DecimalSeparator;
          TDBEdit(Sender).SelStart := Length(TDBEdit(Sender).Text);
        end;
        Exit;
        //verificar se a posicao do cursor esta no comeo
      end
      else if TComponent(Sender) is TEdit then
      begin
        if TEdit(Sender).SelStart = 0 then
        begin
          Exit;
        end;
      end
      else if TComponent(Sender) is TDBEdit then
      begin
        if TDBEdit(Sender).SelStart = 0 then
        begin
          Exit;
        end;
      end;
      //verifica se ja tem um DecimalSeparator na caixa de texto
      for x := 0 to length(Texto) do
      begin
        if Texto[x] = FormatSettings.DecimalSeparator then
        begin
          Exit;
          Break;
        end;
      end;
    end;
  end;
  Result := Key;
end;

function GetVersaoWindows: string;
begin
  case Win32Platform of
    VER_PLATFORM_WIN32s:
      Result := 'Win16_31';
    VER_PLATFORM_WIN32_WINDOWS:
      if Win32MajorVersion <= 4 then
        case Win32MinorVersion of
          0..9: if Trim(Win32CSDVersion) = 'B' then
              Result := 'Win32_95R2'
            else
              Result := 'Win32_95';
          10..89: if Trim(Win32CSDVersion) = 'A' then
              Result := 'Win32_98SE'
            else
              Result := 'Win32_98';
          90..99: Result := 'Win32_ME';
        else
          Result := 'Win32_Future';
        end
      else
        Result := 'Win32_Future';
    VER_PLATFORM_WIN32_NT:
      case Win32MajorVersion of
        3: case Win32MinorVersion of
            1, 10..19: Result := 'WinNT_31';
            5, 50: Result := 'WinNT_35';
            51..99: Result := 'WinNT_351';
          else
            Result := 'WinNT_31';
          end;
        4: Result := 'WinNT_40';
        5: case Win32MinorVersion of
            0: Result := 'WinNT5_2000';
            1: Result := 'WinNT5_XP';
            2: Result := 'WinNT5_2003';
          else
            Result := 'WinNT5_Future';
          end;
      else
        Result := 'WinNT_Future';
      end;
  else
    Result := 'Win_Future';
  end;
end;

function MaxCampo(NomeCampo: string; NomeTabela: string; ConexaoBancoDados: TZConnection): Integer;
var
  oQuery: TZQuery;
  Resultado: Integer;
begin
  oQuery := TZQuery.Create(nil);
  try
    oQuery.Connection := ConexaoBancoDados;
    oQuery.SQL.Clear;
    oQuery.SQL.Add('select max(' + NomeCampo + ') as resultado from ' + NomeTabela);
    oQuery.Open;
    oQuery.First;
    Resultado := oQuery.FieldByName('resultado').AsInteger;
    oQuery.Close;
  finally
    oQuery.Free;
  end;
  Result := Resultado;
end;

function DiaExtenso2(dData: TDateTime): string;
var
  xDia: string;
begin
  case DayOfWeek(dData) of
    1: xDia := 'Domingo';
    2: xDia := 'Segunda';
    3: xDia := 'Tera';
    4: xDia := 'Quarta';
    5: xDia := 'Quinta';
    6: xDia := 'Sexta';
    7: xDia := 'Sbado';
  end;
  DiaExtenso2 := xDia;
end;

function RetornaNumNFP(numero : Integer): string ;
var
  xval : string;
begin
  case numero of
    1: xVal := '1';
    2: xVal := '2';
    3: xVal := '3';
    4: xVal := '4';
    5: xVal := '5';
    6: xVal := '6';
    7: xVal := '7';
    8: xVal := '8';
    9: xVal := '9';
    10: xVal := 'A';
    11: xVal := 'B';
    12: xVal := 'C';
    13: xVal := 'D';
    14: xVal := 'E';
    15: xVal := 'F';
    16: xVal := 'G';
    17: xVal := 'H';
    18: xVal := 'I';
    19: xVal := 'J';
    20: xVal := 'K';
    21: xVal := 'L';
    22: xVal := 'M';
    23: xVal := 'N';
    24: xVal := 'O';
    25: xVal := 'P';
    26: xVal := 'Q';
    27: xVal := 'R';
    28: xVal := 'S';
    29: xVal := 'T';
    30: xVal := 'U';
    31: xVal := 'V';
  end;
  RetornaNumNFP := xVal;
end;

function DiaExtenso(dData: TDateTime): string;
var
  xDia: string;
begin
  case DayOfWeek(dData) of
    1: xDia := 'Domingo';
    2: xDia := 'Segunda-Feira';
    3: xDia := 'Tera-Feira';
    4: xDia := 'Quarta-Feira';
    5: xDia := 'Quinta-Feira';
    6: xDia := 'Sexta-Feira';
    7: xDia := 'Sbado';
  end;
  DiaExtenso := xDia;
end;

function Replicate(Texto: string; QTD: integer): string;
begin
  Result := '';
  while Length(Result) < QTD do
  begin
    Result := Result + Texto;
  end;
  Result := Copy(Result, 1, QTD);
end;

function TextoAEsquerda(Texto: string; TamanhoString: Integer): string;
begin
  Result := Trim(Texto);
  while Length(Result) < TamanhoString do
  begin
    Result := Result + ' ';
  end;
  Result := Copy(Result, 1, TamanhoString);
end;

function TextoADireita(Texto: string; TamanhoString: Integer): string;
begin
  Result := Trim(Texto);
  while Length(Result) < TamanhoString do
  begin
    Result := ' ' + Result;
  end;
  Result := Copy(Result, 1, TamanhoString);
end;

function TextoAoCentro(Texto: string; TamanhoString: Integer): string;
var
  x, EspEsq, EspDir: Integer;
begin
  Result := Trim(Texto);
  x := TamanhoString - Length(Result);
  EspEsq := Trunc(x / 2);
  EspDir := TamanhoString - (Length(Result) + EspEsq);
  for x := 1 to EspEsq do
  begin
    Result := ' ' + Result;
  end;
  for x := 1 to EspDir do
  begin
    Result := Result + ' ';
  end;
  Result := Copy(Result, 1, TamanhoString);
end;

function GetBuildInfo: string;
var
  Prog: string;
  InfoSize, Wnd: DWORD;
  VerBuf: Pointer;
  FI: PVSFixedFileInfo;
  VerSize: DWORD;
begin
  Result := EmptyStr;
  Prog := Application.Exename;
  UniqueString(Prog);
  InfoSize := GetFileVersionInfoSize(PChar(Prog), Wnd);
  if InfoSize <> 0 then
  begin
    GetMem(VerBuf, InfoSize);
    try
      if GetFileVersionInfo(PChar(Prog), Wnd, InfoSize, VerBuf) then
        if VerQueryValue(VerBuf, '\', Pointer(FI), VerSize) then
          Result:= Concat(IntToStr(FI.dwFileVersionMS shr 16), '.',
                          IntToStr(FI.dwFileVersionMS and $FFFF), '.',
                          IntToStr(FI.dwFileVersionLS shr 16), '.',
                          IntToStr(FI.dwFileVersionLS and $FFFF));
    finally
      FreeMem(VerBuf);
    end;
  end;
end;

function GetIP: string;
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
  Name: string;
begin
  WSAStartup(2, WSAData);
  SetLength(Name, 255);
  Gethostname(PAnsiChar(Name), 255);
  SetLength(Name, StrLen(PChar(Name)));
  HostEnt := gethostbyname(PAnsiChar(Name));
  with HostEnt^ do
  begin
    Result := Format('%d.%d.%d.%d', [Byte(h_addr^[0]), Byte(h_addr^[1]), Byte(h_addr^[2]), Byte(h_addr^[3])]);
  end;
  WSACleanup;
end;

function MouseShowCursor(const Show: boolean): boolean;
var
  I: integer;
begin
  I := ShowCursor(LongBool(true));
  if Show then
  begin
    Result := I >= 0;
    while I < 0 do
    begin
      Result := ShowCursor(LongBool(true)) >= 0;
      Inc(I);
    end;
  end
  else
  begin
    Result := I < 0;
    while I >= 0 do
    begin
      Result := ShowCursor(LongBool(false)) < 0;
      Dec(I);
    end;
  end;
end;

function BrowseDialogCallBack(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM): integer stdcall;
var
  wa, rect: TRect;
  dialogPT: TPoint;
begin
  //center in work area
  if uMsg = BFFM_INITIALIZED then
  begin
    wa := Screen.WorkAreaRect;
    GetWindowRect(Wnd, Rect);
    dialogPT.X := ((wa.Right - wa.Left) div 2) - ((rect.Right - rect.Left) div 2);
    dialogPT.Y := ((wa.Bottom - wa.Top) div 2) - ((rect.Bottom - rect.Top) div 2);
    MoveWindow(Wnd, dialogPT.X, dialogPT.Y, Rect.Right - Rect.Left, Rect.Bottom - Rect.Top, True);
  end;
  Result := 0;
end; (*BrowseDialogCallBack*)

function BrowseDialog(const Title: string; const Flag: integer): string;
var
  lpItemID: PItemIDList;
  BrowseInfo: TBrowseInfo;
  DisplayName: array[0..MAX_PATH] of char;
  TempPath: array[0..MAX_PATH] of char;
begin
  Result := '';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  with BrowseInfo do
  begin
    hwndOwner := Application.Handle;
    pszDisplayName := @DisplayName;
    lpszTitle := PChar(Title);
    ulFlags := Flag;
    lpfn := BrowseDialogCallBack;
  end;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then
  begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Result := TempPath;
    GlobalFreePtr(lpItemID);
  end;
  //Exemplo De Uso:
{
uses ShlObj;

procedure TForm1.SelecionarPastaClick(Sender: TObject);
var
  sFolder : string;
begin
  sFolder := BrowseDialog('Select a folder', BIF_RETURNONLYFSDIRS);
  if sFolder <> '' then
    ShowMessage('Selected: ' + #13#10 + sFolder);
end;
}
end;

function ListarArquivos(ListaRetorno: TStrings; DiretorioInicial: string; Mascara: string; RetornarCaminho: Boolean = False; ProcurarEmSubDiretorios: Boolean = False): TStrings;
var
  i: Integer;
  Listatemp: TStrings;
  procedure ListarDiretorios(Folder: string; Lista: TStrings);
  var
    Rec: TSearchRec;
    i: Integer;
    Temps: string;
  begin
    Lista.Clear;
    if SysUtils.FindFirst(Folder + '*', faDirectory, Rec) = 0 then
    try
      repeat
        Lista.Add(Rec.Name);
      until SysUtils.FindNext(Rec) <> 0;
    finally
      if Lista.Count <> 0 then
      begin
        // deleta o diretorio ..
        Lista.Delete(1);
        // deleta o diretorio .
        Lista.Delete(0);
        i := 0;
        //deleta os arquivos isto e fica apenas os diretorios
        if Lista.Count <> 0 then
        begin
          repeat
            Temps := Lista.Strings[i];
            Temps := ExtractFileExt(Temps);
            if Temps <> '' then
              Lista.Delete(i)
            else
              Inc(i);
          until i >= Lista.Count;
        end;
      end;
    end;
  end;

  procedure ListarAtahos(Folder, Mask: string; Lista: TStrings);
  var
    Rec: TSearchRec;
  begin
    Lista.Clear;
    if SysUtils.FindFirst(Folder + Mask, faAnyFile, Rec) = 0 then
    try
      repeat
        Lista.Add(Rec.Name);
      until SysUtils.FindNext(Rec) <> 0;
    finally
      SysUtils.FindClose(Rec);
    end;
  end;

  procedure AddLIstInOther(ListSource, ListDestino: TStrings);
  var
    f: Integer;
  begin
    for f := 0 to ListSource.Count - 1 do
    begin
      ListDestino.Add(ListSource.Strings[f]);
    end;
  end;
begin

  ListaTemp := TStringList.Create;
  ListarAtahos(DiretorioInicial, Mascara, ListaTemp);
  if RetornarCaminho then
  begin
    for i := 0 to ListaTemp.Count - 1 do
    begin
      ListaTemp.Strings[i] := DiretorioInicial + Listatemp.Strings[i];
    end;
  end;
  AddLIstInOther(ListaTemp, ListaRetorno);
  if ProcurarEmSubDiretorios then
  begin
    ListarDiretorios(DiretorioInicial, ListaTemp);
    for i := 0 to listatemp.Count - 1 do
    begin
      ListarArquivos(ListaRetorno, DiretorioInicial + ListaTemp.Strings[i] + '\', Mascara, RetornarCaminho, ProcurarEmSubDiretorios);
    end;
  end;
  ListaTemp.Free;
  Result := ListaRetorno;
  //Exemplo De Uso:
{
procedure TForm1.Button1Click(Sender: TObject);
var
  LA : TStrings;
begin
  LA := TStringList.Create;
  ListarArquivos(LA, 'c:\windows\', '*.exe', True, True);
  ListBox1.Items := LA;
  LA.free;
end;
}
  //Ou:
{
procedure TForm1.Button1Click(Sender: TObject);
var
  LA : TStrings;
begin
  LA := TStringList.Create;
  ListBox1.Items := ListarArquivos(LA, 'c:\windows\', '*.exe', True, True);
  LA.free;
end;
}
end;

procedure TratarErro(Sender: TObject; E: Exception);
var
  NomeDoLog, Tabela1, Tabela2: string;
  Arquivo: TextFile;
begin

  if Pos('is not a valid date', E.Message) > 0 then
  begin
    Alerta('Data Invlida !');
    if TComponent(Sender) is TDBEdit then
    begin
      TDBEdit(Sender).Field.Clear;
      TDBEdit(Sender).SetFocus;
    end;

  end
  else if (Pos('update or delete on "', E.Message) > 0) and (Pos('" violates foreign key constraint "', E.Message) > 0) and (Pos('" on "', E.Message) > 0) then
  begin
    Tabela1 := PrimeiraLetraMaiscula(TiraUnderLine(Copy(E.Message, Pos('update or delete on "', E.Message) + 21, Pos('" violates foreign key constraint "', E.Message) - (Pos('update or delete on "', E.Message) + 21))));
    Tabela2 := PrimeiraLetraMaiscula(TiraUnderLine(Copy(E.Message, Pos('" on "', E.Message) + 6, Length(E.Message) - (Pos('" on "', E.Message) + 6))));
    Alerta('Operao No Pode Ser Executada ! Existe Uma Referencia Entre A Tabela ' + Tabela1 + ' E A Tabela ' + Tabela2 + ' Que No Pode Ser Violada !');

  end
  else if Pos('is not a valid integer value for field', E.Message) > 0 then
  begin
    Alerta(Copy(E.Message, 1, Pos('is', E.Message) - 2) + ' No  Um Nmero Inteiro Vlido Para O Campo !');
    if TComponent(Sender) is TDBEdit then
    begin
      TDBEdit(Sender).Field.Clear;
      TDBEdit(Sender).SetFocus;
    end;

  end
  else if Pos('is not a valid floating point value for field', E.Message) > 0 then
  begin
    Alerta(Copy(E.Message, 1, Pos('is', E.Message) - 2) + ' No  Um Nmero Vlido Para O Campo !');
    if TComponent(Sender) is TDBEdit then
    begin
      TDBEdit(Sender).Field.Clear;
      TDBEdit(Sender).SetFocus;
    end;

  end
  else if Pos('is not a valid integer value', E.Message) > 0 then
  begin
    Alerta(Copy(E.Message, 1, Pos('is', E.Message) - 2) + ' No  Um Nmero Inteiro Vlido Para O Campo !');
    if TComponent(Sender) is TEdit then
    begin
      TEdit(Sender).Clear;
      TEdit(Sender).SetFocus;
    end;

  end
  else if Pos('is not a valid floating point value', E.Message) > 0 then
  begin
    Alerta(Copy(E.Message, 1, Pos('is', E.Message) - 2) + ' No  Um Nmero Vlido !');
    if TComponent(Sender) is TEdit then
    begin
      TEdit(Sender).Clear;
      TEdit(Sender).SetFocus;
    end;

  end
  else
  begin
    Erro('Objeto: ' + screen.ActiveControl.Name + #10 + 'Formulrio: ' + screen.ActiveForm.Name + #10 + 'Erro: ' + E.Message);

    //cria arquivo de log de erro
    NomeDoLog := ChangeFileExt(Application.ExeName, '.log');
    AssignFile(Arquivo, NomeDoLog);
    if FileExists(NomeDoLog) then
      Append(Arquivo) { se existir, apenas adiciona linhas }
    else
      ReWrite(Arquivo); { cria um novo se no existir }
    try
      WriteLn(arquivo, '');
      WriteLn(Arquivo, DateTimeToStr(Now) + ' - IP: ' + GetIP + ' - ' + Trim(FloatToStr(MemoriaEmUso())) + ' % De Memria Em Uso - Formulario: ' + screen.ActiveForm.Name + ' - Objeto: ' + screen.ActiveControl.Name + ' - Erro: ' + E.Message);
      WriteLn(arquivo, '');
      WriteLn(arquivo, '--------------------------------------------------------------------------------------------------------------------------------------------');
    finally
      CloseFile(arquivo)
    end;
    //termino da criacao do arquivo de log de erro
  end;
end;

function transform(nValor: real; cMasck: string): string;
var
  aux: string;
  cont: integer;
  i: integer;
begin
  result := '';
  ///////caso o valor seje zero
  if nValor = 0 then
  begin
    cont := length(cMasck);
    for i := 1 to cont do
    begin
      result := result + ' ';
    end;
    exit;
  end;
  //////
  if pos('.', cMasck) <> 0 then
  begin
    aux := FormatFloat(cMasck, nValor);
    cont := length(cMasck) - length(aux);
    for i := 1 to cont do
    begin
      result := result + ' ';
    end;
    result := result + aux;
  end
  else
  begin
    aux := FloatToStr(nValor);
    cont := length(cMasck) - length(aux);
    for i := 1 to cont do
    begin
      result := result + ' ';
    end;
    result := result + aux;
  end;
end;

function GetSystemPath(): string;
var
  Dir: array[0..255] of Char;
  i: Integer;
  Dn: string;
begin
  GetSystemDirectory(@Dir, 255);
  for i := 0 to 255 do
  begin
    if Ord(Dir[I]) = 0 then
      Break;
    Dn := Dn + Dir[I];
  end;
  Dn := Dn + '\';
  Result := Dn;
end;

function TabelaExisteZeosPG(NomeTabela: string; ConexaoBancoDados: TZConnection): Boolean;
var
 fQuery: TZQuery;
begin
 fQuery := TZQuery.Create(nil);
try
 fQuery.Connection := ConexaoBancoDados;
fQuery.SQL.Clear;
fQuery.SQL.Add('select lower(table_name) as nome_tabela from information_schema.tables where lower(table_type) = :nBT and lower(table_schema) = :nP and trim(lower(table_name)) = trim(lower(:nTab)) order by table_name');
fQuery.ParamByName('nBT').AsString := 'base table';
fQuery.ParamByName('nP').AsString := 'public';
fQuery.ParamByName('nTab').AsString := NomeTabela;
fQuery.Open;

Result := (fQuery.RecordCount > 0);

fQuery.Close;
finally
 fQuery.Free;
end;
end;

function SequenciaExisteZeosPG(NomeSequencia: string; ConexaoBancoDados: TZConnection): Boolean;
var
 fQuery: TZQuery;
begin
 fQuery := TZQuery.Create(nil);
try
 fQuery.Connection := ConexaoBancoDados;
fQuery.SQL.Clear;
fQuery.SQL.Add('SELECT relname FROM pg_class WHERE relkind = :pS AND relnamespace IN ( SELECT oid FROM pg_namespace WHERE nspname NOT LIKE :pPg AND nspname != :pIs ) and (relname = :pSeq)');
fQuery.ParamByName('pS').AsString := 'S';
fQuery.ParamByName('pPg').AsString := 'pg_%';
fQuery.ParamByName('pIs').AsString := 'information_schema';
fQuery.ParamByName('pSeq').AsString := NomeSequencia;
fQuery.Open;

Result := (fQuery.RecordCount > 0);

fQuery.Close;
finally
 fQuery.Free;
end;
end;

function TabelaTempZeosPG(EstruturaTabela: string; ConexaoBancoDados: TZConnection): string;
var
 x: Integer;
TabelaTemp: string;
begin

 x := 0;
repeat
 Inc(x);
TabelaTemp := 'temp' + IntToStr(x);
until (not TabelaExisteZeosPG(TabelaTemp, ConexaoBancoDados));
ExecuteSQL('create table ' + TabelaTemp + ' (' + EstruturaTabela + ')', ConexaoBancoDados);
Result := TabelaTemp;
end;

procedure GetTableNamesZeosPG(ListaTabelas: TStringList; ConexaoBancoDados: TZConnection);
var
 fQuery: TZQuery;
begin
 fQuery := TZQuery.Create(nil);
try
 fQuery.Connection := ConexaoBancoDados;
fQuery.SQL.Clear;
fQuery.SQL.Add('select table_name as nome_tabela from information_schema.tables where lower(table_type) = :nBT and lower(table_schema) = :nP order by table_name');
fQuery.ParamByName('nBT').AsString := 'base table';
fQuery.ParamByName('nP').AsString := 'public';
fQuery.Open;

ListaTabelas.Clear;

fQuery.First;
while not fQuery.Eof do
begin
  ListaTabelas.Add(fQuery.FieldByName('nome_tabela').AsString);
  fQuery.Next;
end;

fQuery.Close;
finally
 fQuery.Free;
end;
end;

function GetVariantType(const v: variant): string;
begin
  case TVarData(v).vType of
    varEmpty: result := 'Empty';
    varNull: result := 'Null';
    varSmallInt: result := 'SmallInt';
    varInteger: result := 'Integer';
    varSingle: result := 'Single';
    varDouble: result := 'Double';
    varCurrency: result := 'Currency';
    varDate: result := 'Date';
    varOleStr: result := 'OleStr';
    varDispatch: result := 'Dispatch';
    varError: result := 'Error';
    varBoolean: result := 'Boolean';
    varVariant: result := 'Variant';
    varUnknown: result := 'Unknown';
    varByte: result := 'Byte';
    varString: result := 'String';
    varTypeMask: result := 'TypeMask';
    varArray: result := 'Array';
    varByRef: result := 'ByRef';
  end;
end;
function ExitWindowsEx(uFlags: integer; dwReserved: word): boolean; // reserved
external 'user32.dll' name 'ExitWindowsEx';

procedure DesligaWindows;
var
  TokenPriv: TTokenPrivileges;
  H: DWORD;
  HToken: THandle;
begin
  {Flag := EWX_POWEROFF;}
  (* WIN 2000 e NT *)
  if Win32Platform = VER_PLATFORM_WIN32_NT then
  begin
    OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES, HToken);
    LookUpPrivilegeValue(nil, 'SeShutdownPrivilege', TokenPriv.Privileges[0].Luid);
    TokenPriv.PrivilegeCount := 1;
    TokenPriv.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
    H := 0;
    AdjustTokenPrivileges(HToken, False, TokenPriv, 0, PTokenPrivileges(nil)^, H);
    CloseHandle(HToken);
  end;
  {ExitWindowsEx(EWX_FORCE or EWX_POWEROFF or EWX_SHUTDOWN, 0);}
end;

procedure ExportaTabelaArquivoTextoZeosPG(NomeArquivo: string; Tabela: TZQuery);
var
  Arquivo: TextFile;
  Texto, NomeColuna, SeparadorColunas: string;
  x: Integer;
begin
  SeparadorColunas := '|-|';
  AssignFile(Arquivo, NomeArquivo);
  try
    if FileExists(NomeArquivo) then
    begin
      Append(Arquivo); { se existir, apenas adiciona linhas }
    end
    else
    begin
      ReWrite(Arquivo); { cria um novo se no existir }
    end;

    Texto := '=>COLUNAS<= ';
    for x := 0 to Tabela.Fields.Count - 1 do
    begin
      NomeColuna := Tabela.Fields.Fields[x].FullName;
      if x = 0 then
      begin
        Texto := Texto + NomeColuna;
      end
      else
      begin
        Texto := Texto + ', ' + NomeColuna;
      end;
    end;
    if Tabela.RecordCount > 0 then
    begin
      WriteLn(Arquivo, Texto);
    end;

    Tabela.First;
    while not Tabela.Eof do
    begin
      Texto := '';
      for x := 0 to Tabela.Fields.Count - 1 do
      begin
        NomeColuna := Tabela.Fields.Fields[x].FullName;
        if x = 0 then
        begin
          Texto := Texto + Tabela.FieldByName(NomeColuna).AsString;
        end
        else
        begin
          Texto := Texto + ' ' + SeparadorColunas + ' ' + Tabela.FieldByName(NomeColuna).AsString;
        end;
      end;
      WriteLn(Arquivo, Texto);

      Tabela.Next;
      Application.ProcessMessages;
    end;
  finally
    CloseFile(Arquivo);
  end;
end;

procedure ImportaArquivoTextoTabelaZeosPG(NomeArquivo: string; NomeTabela: string; ConexaoBancoDados: TZConnection);
var
  Arquivo: TextFile;
  Tmp, Tabela: TZQuery;
  Texto, ValorCampo, SeparadorColunas: string;
  x, Posicao: Integer;
begin
  if not FileExists(NomeArquivo) then
  begin
    Application.MessageBox(Pchar('Arquivo  ' + NomeArquivo + '  No Encontrado !'), 'Ateno', mb_iconExclamation);
  end
  else
  begin
    SeparadorColunas := '|-|';

    AssignFile(Arquivo, NomeArquivo);
    Tmp := TZQuery.Create(nil);
    Tabela := TZQuery.Create(nil);
    try
      Tmp.Connection := ConexaoBancoDados;
      Tabela.Connection := ConexaoBancoDados;

//      Tabela.RequestLive := True;
      Tabela.SQL.Clear;
      Tabela.SQL.Add('select * from ' + NomeTabela + ' where 1 = -1');
      Tabela.Open;

      Reset(Arquivo);
      while not eof(Arquivo) do
      begin
        ReadLn(Arquivo, Texto);
        if Pos('=>COLUNAS<=', Texto) > 0 then
        begin
          Tmp.SQL.Clear;
          Tmp.SQL.Add('select ' + Trim(Copy(Texto, Length('=>COLUNAS<=') + 1, Length(Texto))) + ' from ' + NomeTabela + ' where 1 = -1');
          Tmp.Open;
        end
        else
        begin
          Tabela.Append;
          for x := 0 to Tmp.Fields.Count - 1 do
          begin
            Posicao := Pos(SeparadorColunas, Texto) - 1;
            if Posicao <= 0 then
            begin
              Posicao := Length(Texto)
            end;
            ValorCampo := Copy(Texto, 1, Posicao);

            Tabela.FieldByName(Tmp.Fields.Fields[x].FullName).AsString := Trim(ValorCampo);

            Texto := Copy(Texto, Posicao + 1 + Length(SeparadorColunas), Length(Texto));
          end;
          Tabela.Post;
        end;
        Application.ProcessMessages;
      end;

    finally
      CloseFile(Arquivo);
      Tmp.Free;
      Tabela.Free;
    end;
  end;
end;

function GetWindowsTemp(): string;
var
  Buffer: array[0..MAX_PATH] of Char;
begin
  GetTempPath(SizeOf(Buffer), Buffer);
  Result := Buffer;
end;

function GetDataSistema(const FileName: string): TDateTime;
begin
  Result := FileDateToDateTime(FileAge(FileName));
end;

function RetirarCaracteres(Texto: string; CaracteresRetirar: string): string;
var
  NovoTexto: string;
  x: Integer;
begin
  NovoTexto := '';
  for x := 1 to Length(Texto) do
  begin
    if Pos(Texto[x], CaracteresRetirar) <= 0 then
    begin
      NovoTexto := NovoTexto + Texto[x];
    end;
  end;
  Result := NovoTexto;
end;

function ValidaCPF(NumeroCPF: string): Boolean;
var
  n1, n2, n3, n4, n5, n6, n7, n8, n9: Integer;
  d1, d2: Integer;
  digitado, calculado: string;
begin
  Result := False;
  try
    n1 := StrToInt(NumeroCPF[1]);
    n2 := StrToInt(NumeroCPF[2]);
    n3 := StrToInt(NumeroCPF[3]);
    n4 := StrToInt(NumeroCPF[4]);
    n5 := StrToInt(NumeroCPF[5]);
    n6 := StrToInt(NumeroCPF[6]);
    n7 := StrToInt(NumeroCPF[7]);
    n8 := StrToInt(NumeroCPF[8]);
    n9 := StrToInt(NumeroCPF[9]);
    d1 := n9 * 2 + n8 * 3 + n7 * 4 + n6 * 5 + n5 * 6 + n4 * 7 + n3 * 8 + n2 * 9 + n1 * 10;
    d1 := 11 - (d1 mod 11);
    if d1 >= 10 then
      d1 := 0;
    d2 := d1 * 2 + n9 * 3 + n8 * 4 + n7 * 5 + n6 * 6 + n5 * 7 + n4 * 8 + n3 * 9 + n2 * 10 + n1 * 11;
    d2 := 11 - (d2 mod 11);
    if d2 >= 10 then
      d2 := 0;
    calculado := inttostr(d1) + inttostr(d2);
    digitado := NumeroCPF[10] + NumeroCPF[11];
    if calculado = digitado then
      Result := True;
  except
    Exit;
  end;
end;

function ValidaCGC(NumeroCGC: string): Boolean;
var
  n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12: Integer;
  d1, d2: Integer;
  digitado, calculado: string;
begin
  Result := False;
  if Length(NumeroCGC) < 12 then
  begin
    Exit;
  end;
  try
    n1 := StrToInt(NumeroCGC[1]);
    n2 := StrToInt(NumeroCGC[2]);
    n3 := StrToInt(NumeroCGC[3]);
    n4 := StrToInt(NumeroCGC[4]); // Retira cada numero do Edit, e joda p/ variavel
    n5 := StrToInt(NumeroCGC[5]);
    n6 := StrToInt(NumeroCGC[6]);
    n7 := StrToInt(NumeroCGC[7]);
    n8 := StrToInt(NumeroCGC[8]);
    n9 := StrToInt(NumeroCGC[9]);
    n10 := StrToInt(NumeroCGC[10]);
    n11 := StrToInt(NumeroCGC[11]);
    n12 := StrToInt(NumeroCGC[12]);
    d1 := n12 * 2 + n11 * 3 + n10 * 4 + n9 * 5 + n8 * 6 + n7 * 7 + n6 * 8 + n5 * 9 + n4 * 2 + n3 * 3 + n2 * 4 + n1 * 5;
    d1 := 11 - (d1 mod 11);
    if d1 >= 10 then
      d1 := 0;
    d2 := d1 * 2 + n12 * 3 + n11 * 4 + n10 * 5 + n9 * 6 + n8 * 7 + n7 * 8 + n6 * 9 + n5 * 2 + n4 * 3 + n3 * 4 + n2 * 5 + n1 * 6;
    d2 := 11 - (d2 mod 11);
    if d2 >= 10 then
      d2 := 0;
    calculado := inttostr(d1) + inttostr(d2);
    digitado := NumeroCGC[13] + NumeroCGC[14];
    if calculado = digitado then
      Result := True;
  except
    exit;
  end;
end;

function MemoriaEmUso(): Cardinal;
var
  MemStatus: TMemoryStatus;
begin
  MemStatus.dwLength := SizeOf(MemStatus);
  GlobalMemoryStatus(MemStatus);
  Result := MemStatus.dwMemoryLoad;
end;

function iif(ValorAtual, ValorComparar, ResultadoVerdadeiro, ResultadoFalso: Variant): Variant;
begin
  result := '';
  if ValorAtual = ValorComparar then
  begin
    result := ResultadoVerdadeiro;
  end
  else
  begin
    result := ResultadoFalso;
  end;
end;

function QtdDiasUteis(DataIni, DataFim: TDate): Integer;
var
  nX, nDias: Integer;
begin
  nX := 0;
  nDias := 0;
  while (DataIni + nX) <= DataFim do
  begin
    // 1 - Domingo, 2 - Segunda-Feira, ... , 6 - Sexta-Feira, 7 - Sbado
    if DayOfWeek(DataIni + nX) in [2..6] then
    begin
      Inc(nDias);
    end;
    Inc(nX);
  end;
  Result := nDias;
end;

function QtdDiasPeriodo(DataIni, DataFim: TDate; DiasSemana: string = '1234567'): Integer;
var
  nX, nDias: Integer;
begin
  nX := 0;
  nDias := 0;
  while (DataIni + nX) <= DataFim do
  begin
    // 1 - Domingo, 2 - Segunda-Feira, ... , 6 - Sexta-Feira, 7 - Sbado
    if Pos(IntToStr(DayOfWeek(DataIni + nX)), DiasSemana) > 0 then
    begin
      Inc(nDias);
    end;
    Inc(nX);
  end;
  Result := nDias;
end;

function EOM(Data: TDateTime): TDateTime;
var
  ultDia: integer;
  strAux: string;
begin
  ultDia := UltimoDiaMes(Data);
  strAux := strzero(ultDia, 2) + '/' + strzero(Mes(Data), 2) + '/' + intTostr(ano(data));
  result := strToDate(strAux);
end;

function RetornaIndiceColuna(StrNomeColuna: string; GridTab: TcxGridDBTableView): integer;
var
  i: integer;
begin
  result := -1;
  for i := 0 to GridTab.ColumnCount - 1 do
  begin
    if Trim(LowerCase(GridTab.Columns[i].Name)) = Trim(LowerCase(StrNomeColuna)) then
    begin
      result := i;
      break;
    end;
  end;
end;

function ValorToTexto(Valor: Double): string;
var
  aux: string;
  i: integer;
begin
  aux := formatcurr('#,##0.00', Valor);
  result := '';
  for i := 1 to length(aux) do
  begin
    if (aux[i] <> ',') and (aux[i] <> '.') then
    begin
      result := result + aux[i];
    end;

  end;

end;

function RetornaTipoCampoTabela(Tabela: TZQuery; NomeCampo: string): string;
var
  aux: TFieldType;
begin
  aux := Tabela.FieldDefs.Items[Tabela.FieldDefs.IndexOf(NomeCampo)].DataType;
  if (aux = ftFloat) or (aux = ftCurrency) or (aux = ftFMTBcd) or (aux = ftLargeint) then
    RetornaTipoCampoTabela := 'NUMERO'
  else if (aux = ftSmallint) or (aux = ftInteger) or (aux = ftWord) or (aux = ftAutoInc) then
    RetornaTipoCampoTabela := 'INTEIRO'
  else if (aux = ftString) or (aux = ftFixedChar) or (aux = ftWideString) then
    RetornaTipoCampoTabela := 'TEXTO'
  else if (aux = ftDate) or (aux = ftTime) or (aux = ftDateTime) or (aux = ftTimeStamp) then
    RetornaTipoCampoTabela := 'DATA'
  else
    RetornaTipoCampoTabela := 'DESCONHECIDO';
end;

function StrIsInteger(const S: String): boolean;
begin
  try
    StrToInt(S);
    Result := True;
  except
    Result := False;
  end;
end;

function NumeroOuLetra(Palavra:String; Tamanho:Integer) : string;
var
  S, Resultado:string;
begin
  S := Copy(Palavra,Length(Palavra), Tamanho);
  if StrIsInteger(S) then
  begin
    Resultado := ' ';
  end
  else
  begin
    Resultado := S;
  end;
  Result := Resultado;
end;

function TiraNulo(Palavra : string): string;
var
 i : integer ;
 aux : string;
begin
  for i := 1 to length(Palavra) do
  begin
     if Palavra[i] <> #0 then
     begin
       aux := aux + Palavra[i] ;
    end;
  end;
  Result := aux;
end;

function TiraEnter(Palavra : string): string;
var
 i : integer ;
 aux : string;
begin
  for i := 1 to length(Palavra) do
  begin
    if (Palavra[i] <> #$D) or (Palavra[i] <> #$A) then
//    if (Palavra[i] <> #13) or (Palavra[i] <> #10) or (Palavra[i] <> #10#13) or (Palavra[i] <> #$D#$A) then
    begin
      aux := aux + Palavra[i] ;
    end;
  end;
  Result := aux;
end;

function CampoExiste(tabela:string; campo:string; BancoDados:TZConnection): Boolean;
var
  Query:TZQuery;
//  teste: Variant;
begin
  Result := False;
  Query := TZQuery.Create(nil);
  try
    try
      Query.Connection := BancoDados;
      Query.SQL.Clear;
      Query.SQL.Add('select * from ' + tabela + ' where 1=-1');
      Query.Open;
      if Query.FindField(campo) <> nil then
      begin
        Result := True;
      end;
    except

    end;
    Query.Close;
  finally
    Query.Free;
  end;
end;

function ArredontaFloat(x : Real): Real;
Begin
  if x > 0 Then
    begin
      if Frac(x) > 0.5 Then
        begin
          x := x + 1 - Frac(x);
        end
      else
        begin
          x := x - Frac(x);
        end;
    end
  else
    begin
      x := x - Frac(x);
    end;
  result := x
end;

function BuscaTroca(Text,Busca,Troca : string) : string;
{ Substitui caracteres dentro da string}
var n : integer;
begin
  for n := 1 to length(Text) do
  begin
    if Copy(Text,n,1) = '' then
    begin
      Delete(Text,n,1);
      Insert('o',Text,n);
    end;
    if Copy(Text,n,1) = '' then
    begin
      Delete(Text,n,1);
      Insert('A',Text,n);
    end;
    if Copy(Text,n,1) = '' then
    begin
      Delete(Text,n,1);
      Insert('I',Text,n);
    end;
    if Copy(Text,n,1) = '' then
    begin
      Delete(Text,n,1);
      Insert('E',Text,n);
    end;
    if Copy(Text,n,1) = '' then
    begin
      Delete(Text,n,1);
      Insert('C',Text,n);
    end;
    if Copy(Text,n,1) = Busca then
    begin
      Delete(Text,n,1);
      Insert(Troca,Text,n);
    end;
  end;
  Result := Text;
end;

function VerificaNumero(palavra : string): Boolean;
var
  flag : Boolean ;
  i : Integer;
  aux : string;
begin
  flag := True;
  aux := palavra;
  for i := 1 to Length(aux) do
  begin
    if not (aux[i] in ['0'..'9']) then
    begin
      flag := False;
      Break;
    end;
  end;
  Result := flag;
end;

function RoundCustom(Valor_Inicial: Double; Valor_Arredondar: Double): Double;
var
  aux, Resultado:Double;
begin
  aux := Valor_Inicial;
  if Frac(aux) < Valor_Arredondar then
  begin
    Resultado := Int(aux);
  end
  else
  begin
    Resultado := Int(aux) + 1;
  end;
  Result := Resultado;
end;

function ProcuraStringNoArquivo(Palavra : String; NomeDoArquivo : string): TStringList;
var
  Lista : TStringList;
  x : Integer;
begin
  Lista := TStringList.Create;
  try
    Lista.LoadFromFile(NomeDoArquivo);
    for x := 0 to Lista.Count -1 do
    begin
      if pos(Palavra, Lista.Strings[x]) > 0 then
      begin
        Result.Append(Lista.Strings[x]);
      end;
    end;
  finally
    Lista.Free;
  end;
end;

function ExecAndWait(const FileName, Params: string; const WindowState: Word): boolean;
var
  SUInfo: TStartupInfo;
  ProcInfo: TProcessInformation;
  CmdLine: string;
begin
  { Coloca o nome do arquivo entre aspas. Isto  necessrio devido aos espaos contidos em nomes longos }
  CmdLine := '"' + Filename + '"' + Params;
  FillChar(SUInfo, SizeOf(SUInfo), #0);
  with SUInfo do
  begin
    cb := SizeOf(SUInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    wShowWindow := WindowState;
  end;
  Result := CreateProcess(nil, PChar(CmdLine), nil, nil, false,
  CREATE_NEW_CONSOLE or NORMAL_PRIORITY_CLASS, nil,
  PChar(ExtractFilePath(Filename)), SUInfo, ProcInfo);

  { Aguarda at ser finalizado }
  if Result then
  begin
    WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    { Libera os Handles }
    CloseHandle(ProcInfo.hProcess);
    CloseHandle(ProcInfo.hThread);
  end;
end; //- Exemplo de uso:

function TiraZeroEsquerda(Valor : string) : string;
var
  Aux, conteudo : string;
  x : Integer;
begin
  conteudo := '';
  Aux := '';

  Aux := Valor;
  for x := 1 to Length(Aux) do
  begin
    if (Aux[x] <> '0') then
    begin
      conteudo := conteudo + Copy(Aux, x, Length(Aux));
      Break;
    end;
  end;
  Result := conteudo;
end;

function ExcelToStringGrid(AGrid: TStringGrid; AXLSFile: string): Boolean;
const
  xlCellTypeLastCell = $0000000B;
var
  AplicacaoExcel, Folha: OLEVariant;
  Matriz: Variant;
  x, y, k, r: Integer;
begin
  Result:=False;
  //Cria Excel- OLE Object
  AplicacaoExcel:=CreateOleObject('Excel.Application');
  try
    //Esconde Excel
    AplicacaoExcel.Visible:=False;
    //Abre o Workbook
    AplicacaoExcel.Workbooks.Open(AXLSFile);
    Folha:=AplicacaoExcel.Workbooks[ExtractFileName(AXLSFile)].WorkSheets[1];
    Folha.Cells.SpecialCells(xlCellTypeLastCell, EmptyParam).Activate;
    //Pegar o nmero da ltima linha
    x:=AplicacaoExcel.ActiveCell.Row;
    //Pegar o nmero da ltima coluna
    y:=AplicacaoExcel.ActiveCell.Column;
    //Seta Stringgrid linha e coluna
    AGrid.RowCount:=x;
    AGrid.ColCount:=y;
    //Associaca a variant WorkSheet com a variant do Delphi
    Matriz:=AplicacaoExcel.Range['A1', AplicacaoExcel.Cells.Item[X, Y]].Value;
    //Cria o loop para listar os registros no TStringGrid
    k:=2;
    repeat
      for r:=1 to y do
//          AGrid.Cells[(r - 1),(k - 1)]:=Matriz[K, R];
          AGrid.Cells[(r),(k)]:=Matriz[K, R];
      Inc(k);
    until k > x;
    Matriz:=Unassigned;
  finally
    //Fecha o Excel
    if not VarIsEmpty(AplicacaoExcel) then
    begin
    AplicacaoExcel.Quit;
    AplicacaoExcel:=Unassigned;
    Folha:=Unassigned;
    Result:=True;
    end;
  end;
end;

procedure AtalhoParaDesktop(FileName : string; Caption : widestring);
var
  IObject : IUnknown;
  ISLink : IShellLink;
  IPFile : IPersistFile;
  PIDL : PItemIDList;
  InFolder : array[0..MAX_PATH] of Char;
  TargetName : String;
  LinkName : WideString;
  FLinkName : String;
begin
  TargetName := FileName;
  {Use TargetName:=ParamStr(0) which returns the path and file name of the executing program to create a link to your Application}

  IObject := CreateComObject(CLSID_ShellLink);
  ISLink := IObject as IShellLink;
  IPFile := IObject as IPersistFile;

  with ISLink do begin
    SetPath(pChar(TargetName));
    SetWorkingDirectory(pChar(ExtractFilePath(TargetName)));
  end;

  // if we want to place a link on the Desktop
  SHGetSpecialFolderLocation(0, CSIDL_DESKTOPDIRECTORY, PIDL);
  SHGetPathFromIDList(PIDL, InFolder);

  {or if we want a link to appear in some other, not-so-special, folder: InFolder := 'c:SomeFolder'}

  FlinkName := ''+ Caption + '.lnk';

  LinkName := InFolder + FlinkName;
  IPFile.Save(PWChar(LinkName), false);
end;

function TiraExtensao(S: string): string;
begin
  Result := ExtractFileName(S);
end;

function UFToInt(pUF: String): Integer;
begin
  Result := 0;
  if pUF = 'RO' then Result := 11;
  if pUF = 'AC' then Result := 12;
  if pUF = 'AM' then Result := 13;
  if pUF = 'RR' then Result := 14;
  if pUF = 'PA' then Result := 15;
  if pUF = 'AP' then Result := 16;
  if pUF = 'TO' then Result := 17;
  if pUF = 'MA' then Result := 21;
  if pUF = 'PI' then Result := 22;
  if pUF = 'CE' then Result := 23;
  if pUF = 'RN' then Result := 24;
  if pUF = 'PB' then Result := 25;
  if pUF = 'PE' then Result := 26;
  if pUF = 'AL' then Result := 27;
  if pUF = 'SE' then Result := 28;
  if pUF = 'BA' then Result := 29;
  if pUF = 'MG' then Result := 31;
  if pUF = 'ES' then Result := 32;
  if pUF = 'RJ' then Result := 33;
  if pUF = 'SP' then Result := 35;
  if pUF = 'PR' then Result := 41;
  if pUF = 'SC' then Result := 42;
  if pUF = 'RS' then Result := 43;
  if pUF = 'MS' then Result := 50;
  if pUF = 'MT' then Result := 51;
  if pUF = 'GO' then Result := 52;
  if pUF = 'DF' then Result := 53;

end;
  function TiraTraco(valor: string): String;
 var i: integer;
 begin
      for i := 0 to Length(valor) do
        begin
        if valor[i]='-' then
           begin
                delete(valor,i,1);
           end
        end;
        Result := valor;
 end;

function ProcessArquivo(const Origem, Destino : string; Operacao, Modo:Integer) : Boolean;
 // Requer a unit ShellApi na clausula uses da unit
  Const  Aborted : Boolean = False;
  var  shfo : TSHFileOpStruct;
  begin
    FillChar(shfo,SizeOf(shfo),$0);
    with shfo do
    begin
      if Operacao > 2 then
      begin
        operacao := 2;
      end;
      if Modo > 5 then
      begin
       modo := 1;
      end;
      case operacao of
        1: wFunc := FO_MOVE;
        2: wFunc := FO_COPY;
      end;
      pFrom := Pchar(Origem);
      pTo := Pchar(Destino);
      case Modo of
        1: fFlags := FOF_SILENT;
        2: fFlags := FOF_ALLOWUNDO or FOF_FILESONLY;
        3: fFlags := FOF_RENAMEONCOLLISION;
        4: fFlags := FOF_NOCONFIRMATION;
        5: fFlags := FOF_SIMPLEPROGRESS;
      end;
    end;
  Result := (SHFileOperation(shfo)= 0) and (not Aborted);

 // Onde OPERACAO: 1 (Move arquivo), 2 (Copia arquivo)
 // Onde MODO: 5 (Aparece a janela de cpia de arquivo do windows)

 end;

 //Cria Digito EAN

 //Pegar Serial do HD
 Function SerialNumHD(FDrive:String) :String;
    Var
       Serial:DWord;
       DirLen,Flags: DWord;
       DLabel : Array[0..11] of Char;
 begin
       Try
          GetVolumeInformation(PChar(FDrive+':\'),dLabel,12,@Serial,DirLen,Flags,nil,0);
          Result := IntToHex(Serial,8);
       Except Result := '';
    end;
 end;


  //Gera Serial de Licensa do SAC
 function GeraSerial2(Name:string):string;
var
  key1, key2, key3, key4, d : DWORD;
  s : string;
begin
  key1 := 0;
  key2 := 0;
  key3 := 0;
  key4 := 0;

  for d := 1 to Length(name) do
  begin
    key2 := ((Ord(Name[d]) shl $1E) + $C0D1) - ((Ord(Name[d]) shr $1F) + $C0D2);
    key1 := ((Ord(Name[d]) shl $1E) + $C0D1) xor key2 + Ord(Name[d]);
    key3 := key3 + (key1 + key2);
    key4 := key2 * key1 + key3;
    key1 := key1 - key3;
  end;

  Result := Copy(IntToHex(key3,1),0,4)+'-'+Copy(IntToHex(key3,1),4,4)+'-'+copy(IntToHex(key1,1),0,4)+'-'+copy(IntToHex(key4,1),0,4);
end;

function tbGetEnvVar(const VarName: string): string;
var
  I: integer;
begin
  Result := '';
  I := length(GetEnvironmentVariable(VarName));
  if I > 0 then
  begin
    result := GetEnvironmentVariable(VarName);
  end;
end;

function Coalesce(Value1: Variant; Value2: Variant): Variant; overload;
begin
  if not VarIsNull(Value1) then
    Result := Value1
  else
    Result := Value2
end;

{ 
*********************************************} 
{ Set Global Environment Function } 
{ Coder : Kingron,2002.8.6 } 
{ Bug Report : Kingron@163.net } 
{ Test OK For Windows 2000 Advance Server } 
{ Parameter: } 
{ Name : environment variable name } 
{ Value: environment variable Value } 
{ Ex: SetGlobalEnvironment(\'MyVar\',\'OK\') } 
{*********************************************} 


function setGlobalEnvironment(const Name, Value: string;
const User: Boolean = True): Boolean;
resourcestring 
REG_MACHINE_LOCATION = 'System\\CurrentControlSet\\Control\\Session Manager\\Environment\';
REG_USER_LOCATION = 'Environment\';
begin 
  with TRegistry.Create do
  try
    if User then { User Environment Variable }
      Result := OpenKey(REG_USER_LOCATION, True)
    else { System Environment Variable }
    begin
      RootKey := HKEY_LOCAL_MACHINE;
      Result := OpenKey(REG_MACHINE_LOCATION, True);
    end;
    if Result then
    begin
      WriteString(Name, Value); { Write Registry for Global Environment }
      { Update Current Process Environment Variable }
      SetEnvironmentVariable(PChar(Name), PChar(Value));
      { Send Message To All Top Window for Refresh }
      SendMessage(HWND_BROADCAST, WM_SETTINGCHANGE, 0, Integer(PChar('Environment\')));
    end;
  finally
    Free;
  end;
end; { SetGlobalEnvironment }

function ConstraintExiste(NomeTabela, NomeConstraint: string; BancoDados : TZConnection): Boolean;
  var
    WQuery : TZQuery;
begin
  WQuery := TZQuery.Create(nil);
  try
    WQuery.Connection := BancoDados;
    WQuery.SQL.Clear;
    WQuery.SQL.Text := 'SELECT tc.constraint_name, tc.table_name FROM information_schema.table_constraints AS tc  ' +
                       'WHERE LOWER(tc.table_name)=:wTable and LOWER(tc.constraint_name) =:wConstraint';
    WQuery.ParamByName('wTable'     ).AsString := LowerCase(NomeTabela);
    WQuery.ParamByName('wConstraint').AsString := LowerCase(NomeConstraint);
    WQuery.Open;

    if WQuery.RecordCount = 0 then
      Result := False
    else
      Result := True;

    WQuery.Close;
  finally
    WQuery.Free;
  end;
end;

function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; Tamanho, TamanhoScale : Double; BancoDados: TZConnection): Boolean; overload;
var
  TabelasColunas : TZQuery;
begin
  TabelasColunas := TZQuery.Create(nil);
  try
    TabelasColunas.Connection := BancoDados;
    TabelasColunas.SQL.Text := 'select table_name, column_name, data_type, character_maximum_length, numeric_precision, numeric_scale ' +
                               'from information_schema.columns where table_schema = ''public'' and table_name = LOWER(:wTAB) and column_name = LOWER(:wCOL)';
    TabelasColunas.ParamByName('wTAB').AsString := Tabela;
    TabelasColunas.ParamByName('wCOL').AsString := Coluna;
    TabelasColunas.Open;

    Tipo := LowerCase(Tipo);

    if TabelasColunas.RecordCount > 0 then
    begin
      if (Tipo = 'character') or (Tipo = 'character varying') then
        if (TabelasColunas.FieldByName('data_type').AsString <> Tipo) or
           (TabelasColunas.FieldByName('character_maximum_length').AsFloat <> Tamanho) then
          Result := True
        else
          Result := False
      else
      if (Tipo = 'numeric') then
        if (TabelasColunas.FieldByName('data_type').AsString <> Tipo) or
           (TabelasColunas.FieldByName('numeric_precision').AsFloat <> Tamanho) or
           (TabelasColunas.FieldByName('numeric_scale'    ).AsFloat <> TamanhoScale) then
          Result := True
        else
          Result := False
      else
        if (TabelasColunas.FieldByName('data_type').AsString <> Tipo) then
          Result := true
        else
          Result := false;
    end
    else
      Result := False;

    TabelasColunas.Close;
  finally
    TabelasColunas.Free;
  end;
end;

function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; BancoDados: TZConnection): Boolean; overload;
begin
  Result := ConsultaTipoColunas(Tabela, Coluna, Tipo, 1, 1, BancoDados);
end;

function ConsultaTipoColunas(Tabela, Coluna, Tipo : string; Tamanho : Double; BancoDados: TZConnection): Boolean; overload;
begin
  Result := ConsultaTipoColunas(Tabela, Coluna, Tipo, Tamanho, 1, BancoDados);
end;

function RetornaSomenteNumeros(const S: string): string;
var
  vText : PChar;
begin
  vText := PChar(S);
  Result := '';

  while (vText^ <> #0) do
  begin
    {$IFDEF UNICODE}
    if CharInSet(vText^, ['0'..'9']) then
    {$ELSE}
    if vText^ in ['0'..'9'] then
    {$ENDIF}
      Result := Result + vText^;

    Inc(vText);
  end;
end;

function IsAphaNumerico(S : string) : Boolean;
var
  Valor,
  I : Integer;
begin
  for I := 1 to Length(S) do
  begin
    if not TryStrToInt(S[I], Valor) then
    begin
      Result := True;
      Exit;
    end;
  end;

  Result := False;
end;

function VerificaLicencaSistema(pBancoDados : TZConnection) : Boolean;
var
  wQuery : TZQuery;
begin
  try
    wQuery := TZQuery.Create(nil);
    try
      wQuery.Connection := pBancoDados;

      wQuery.Close;
      wQuery.SQL.Text := 'SELECT * FROM TAB_EMPRESA_CONTRATO AS TC WHERE TC.ATIVO = TRUE';
      wQuery.Open;

      Result := wQuery.RecordCount > 0;
    finally
      wQuery.Free;
    end;
  except

  end;

end;

end.
