unit uThreadEmail;

interface

uses
  Classes;

type
  ThreadEmail = class(TThread)

  private
    { Private declarations }
     procedure conectar;
  protected
    procedure Execute; override;

  end;

implementation
uses funcoes, SysUtils, uFrmMenu;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure ThreadEmail.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ ThreadEmail }

procedure ThreadEmail.Execute;
begin
  { Place thread code here }
  conectar;
end;


procedure ThreadEmail.conectar;
Var
 xAnexo: Integer;
begin
  try
    FrmMenu.enviar.Caption := 'Enviando';
    FrmMenu.enviar.Enabled := false;
    with FrmMenu.IdMessage do
    begin
       //Body.Add(mensagem);
       Body.Text := 'Assunto: '+FrmMenu.assunto.Text + #13 + 'Nome: '+FrmMenu.nome.Text + #13 + 'Email: '+FrmMenu.eemail.Text + #13 + 'Mensagem: ' + FrmMenu.MMmensagem.Lines.Text;
       From.Address := 'sistemacomercialsac@gmail.com'; //opcional
       From.Name := 'Mensagem enviada pelo SAC'; //opcional
       Recipients.EMailAddresses := trim('net-solutions@hotmail.com');
       Subject := 'Assunto: '+FrmMenu.assunto.Text;
       //Chama o procedimento que conecta
       if FrmMenu.IdSMTP.Connected then
       begin
         FrmMenu.idSMTP.Send(FrmMenu.IdMessage);
       end else
       begin
         FrmMenu.idSMTP.Connect;
         FrmMenu.idSMTP.Send(FrmMenu.IdMessage);
       end; 
    end;
    FrmMenu.IdSMTP.Disconnect;
    FrmMenu.nome.text := 'Seu Nome';
    FrmMenu.eemail.text := 'Seu Email';
    FrmMenu.assunto.text := 'Assunto';
    frmMenu.MMMensagem.text := '';

    Alerta('Mensagem enviada com sucesso!');
  finally
    FrmMenu.enviar.Caption := 'Enviar';
    FrmMenu.enviar.Enabled := true;
  end;
end;

end.
