unit UFrmCadastroEstudantes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, Grids, DBGrids, ExtCtrls, StdCtrls, Buttons, SqlExpr, DB,
  Mask, DBCtrls, FMTBcd, QDialogs, Provider, DBClient,
  ZAbstractRODataset, ZAbstractDataset, ZDataset;

Const
  // Contantes reponsaveis pelo nome da tabela e o nome do campo principal (geralmente um campo que nao se repete "unico")
  TabelaReferencial = 'alunos';
  CampoReferencial = 'codigo';

type
  TFrmCadastroEstudantes = class(TForm)
    PageControl: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Panel1: TPanel;
    DBGrid: TDBGrid;
    Panel2: TPanel;
    pesquisar: TBitBtn;
    ChavePesquisa: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    incluir: TBitBtn;
    alterar: TBitBtn;
    excluir: TBitBtn;
    salvar: TBitBtn;
    abandonar: TBitBtn;
    codigo: TDBEdit;
    CampoPesquisa: TComboBox;
    DataSource: TDataSource;
    SqlManipula: TZQuery;
    nome: TDBEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    endereco: TDBEdit;
    Label6: TLabel;
    Cidade: TDBEdit;
    cep: TDBEdit;
    Label7: TLabel;
    uf: TDBEdit;
    Label8: TLabel;
    Serie: TDBEdit;
    Label9: TLabel;
    Label10: TLabel;
    DATA_INICIO: TDBEdit;
    Label11: TLabel;
    ativo: TDBRadioGroup;
    Codigo_escola: TDBEdit;
    nome_escola: TDBEdit;
    Label15: TLabel;
    Label16: TLabel;
    Pesquisa_escola: TSpeedButton;
    codigo_curso: TDBEdit;
    Pesquisa_curso: TSpeedButton;
    nome_curso: TDBEdit;
    Label17: TLabel;
    Label18: TLabel;
    codigo_motorista: TDBEdit;
    Pesquisa_motorista: TSpeedButton;
    nome_motorista: TDBEdit;
    Label19: TLabel;
    Label20: TLabel;
    SqlManipulacodigo: TIntegerField;
    SqlManipulanome: TStringField;
    SqlManipulaendereco: TStringField;
    SqlManipulacep: TStringField;
    SqlManipulaestado: TStringField;
    SqlManipulacidade: TStringField;
    SqlManipulacodigo_escola: TIntegerField;
    SqlManipulaescola: TStringField;
    SqlManipulacodigo_curso: TIntegerField;
    SqlManipulacurso: TStringField;
    SqlManipulaserie: TStringField;
    SqlManipulaperiodo: TStringField;
    SqlManipulacodigo_motorista: TIntegerField;
    SqlManipulamotorista: TStringField;
    SqlManipulaativo: TStringField;
    dbBairro: TDBEdit;
    Label21: TLabel;
    SqlManipulatelefone: TStringField;
    SqlManipulabairro: TStringField;
    PERIODO: TDBComboBox;
    todos_dias: TDBCheckBox;
    groupSenama: TGroupBox;
    segunda: TDBCheckBox;
    domingo: TDBCheckBox;
    terca: TDBCheckBox;
    quarta: TDBCheckBox;
    quinta: TDBCheckBox;
    sexta: TDBCheckBox;
    sabado: TDBCheckBox;
    funcionario_publico: TDBCheckBox;
    reparticao: TDBEdit;
    Label12: TLabel;
    SqlManipularg: TStringField;
    SqlManipulatodos_dias: TBooleanField;
    SqlManipulasegunda_feira: TBooleanField;
    SqlManipulaterca_feira: TBooleanField;
    SqlManipulaquarta_feira: TBooleanField;
    SqlManipulaquinta_feira: TBooleanField;
    SqlManipulasexta_feira: TBooleanField;
    SqlManipulasabado: TBooleanField;
    SqlManipuladomingo: TBooleanField;
    SqlManipuladata_inicio: TDateField;
    SqlManipulafuncionario_publico: TBooleanField;
    SqlManipulareparticao: TStringField;
    inicio_pagamento: TDBEdit;
    Label13: TLabel;
    codigo_valor: TDBEdit;
    pesquisa_valor: TSpeedButton;
    descricao_valor: TDBEdit;
    Label14: TLabel;
    Label22: TLabel;
    SqlManipulainicio_aula: TStringField;
    SqlManipulatermino_aula: TStringField;
    SqlManipuladata_inicio_pagamento: TDateField;
    SqlManipulacodigo_valor: TIntegerField;
    SqlManipuladescricao_valor: TStringField;
    GroupBox1: TGroupBox;
    ida: TDBCheckBox;
    volta: TDBCheckBox;
    SqlManipulaida: TBooleanField;
    SqlManipulavolta: TBooleanField;
    procedure FormShow(Sender: TObject);
    procedure DBGridTitleClick(Column: TColumn);
    procedure pesquisarClick(Sender: TObject);
    procedure DBGridDblClick(Sender: TObject);
    procedure incluirClick(Sender: TObject);
    procedure alterarClick(Sender: TObject);
    procedure excluirClick(Sender: TObject);
    procedure salvarClick(Sender: TObject);
    procedure abandonarClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure HabilitaBotoes(aOpcao:integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);  // Linka os envento corsaida nos objetos
    function ValidaDados(aValor: String):boolean;
    function RetornaTipoCampo(NomeCampo : String): String;
    procedure Ordenar_Select(OS_Campo: String);
    procedure PageControlChanging(Sender: TObject; var AllowChange: Boolean);
    procedure ColocaMascaraCampos();
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure Codigo_escolaExit(Sender: TObject);
    procedure codigo_cursoExit(Sender: TObject);
    procedure codigo_motoristaExit(Sender: TObject);
    procedure Pesquisa_escolaClick(Sender: TObject);
    procedure Pesquisa_cursoClick(Sender: TObject);
    procedure Pesquisa_motoristaClick(Sender: TObject);
    procedure valor_passeKeyPress(Sender: TObject; var Key: Char);
    procedure Codigo_escolaKeyPress(Sender: TObject; var Key: Char);
    procedure codigo_cursoKeyPress(Sender: TObject; var Key: Char);
    procedure codigo_motoristaKeyPress(Sender: TObject; var Key: Char);
    procedure todos_diasClick(Sender: TObject);
    procedure habilitaDiasSemana();
    procedure habilitaFuncPublico();
    procedure funcionario_publicoClick(Sender: TObject);
    procedure pesquisa_valorClick(Sender: TObject);
    procedure codigo_valorExit(Sender: TObject);
  private
    { Private declarations }
    nFlagAlterar: boolean;
  public
    { Public declarations }
  end;

var
  FrmCadastroEstudantes: TFrmCadastroEstudantes;

implementation

uses funcoes, uBancoDados, UfrmPesquisaSimples;
{$R *.dfm}

procedure TFrmCadastroEstudantes.FormShow(Sender: TObject);
var
  i : integer;
begin

  //define a pagina corrente ( Pesquisa )
  pagecontrol.TabIndex := 0;

  /// inicia o flag com false, pois nao est em mode alteracao
  nFlagAlterar := false ;

  //abre a tabela
  SQLManipula.Close;
  SQLManipula.SQL.Clear;
  SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL');
  SQLManipula.Open;

  // linka o ClientDataSet no datasource
  DataSource.DataSet := SQLManipula;
  DataSource.Enabled := true;

  // Linka o datasource no grid de pesquisa
  dbgrid.DataSource := DataSource;
  //Cria Colunas em run Time
  dbgrid.Columns.State := csCustomized;

  for i := 0 to SQLManipula.FieldDefs.Count - 1 do begin
    //joga nome dos campos da tabela no ComboBox e trata o nome dos campos
    CampoPesquisa.Items.Add(PrimeiraLetraMaiscula(TiraUnderline(SQLManipula.FieldDefs.Items[i].Name)));
    //Para emiminar a coluna que j existe no grid
    if i <> 0 then begin
      DBGrid.Columns.Add;
    end;
    //adiciona nome dos campos da tabela no Grid e trata o nome das colunas
    DBGrid.Columns[i].FieldName := SQLManipula.FieldDefs.Items[i].Name;
    DBGrid.Columns[i].Title.Caption := PrimeiraLetraMaiscula(TiraUnderline(SQLManipula.FieldDefs.Items[i].Name));
    DBGrid.Columns[i].Title.Font.Style := [ fsBold ];
  end;

  // linka todos os campos DBEdit ao Data Source
  // linka todos os campos DBEdit ao determinado DataField (FieldName)
  for i := 0 to ComponentCount -1 do begin
    if Components[i] is TDBEdit then
      TDBEdit(Components[i]).DataSource := DataSource;
    if Components[i] is TDBRadioGroup then
      TDBRadioGroup(Components[i]).DataSource := DataSource;
    if Components[i] is TDBCheckBox then
     TDBCheckBox(Components[i]).DataSource := DataSource;
    if Components[i] is TDBComboBox then
     TDBComboBox(Components[i]).DataSource := DataSource;
    end;

  // Lista todos os campos com o determinado fieldname
  codigo.DataField := 'codigo';
  nome.DataField := 'nome';
  endereco.DataField := 'endereco';
  cep.DataField := 'cep';
  uf.DataField := 'estado';
  dbBairro.DataField := 'bairro';
  cidade.DataField := 'cidade';
  codigo_escola.DataField := 'codigo_escola';
  nome_escola.DataField := 'escola';
  codigo_curso.DataField := 'codigo_curso';
  nome_curso.DataField := 'curso';
  serie.DataField := 'serie';
  periodo.DataField := 'periodo';
  DATA_INICIO.DataField := 'data_inicio';
  todos_dias.DataField := 'todos_dias' ;
  segunda.DataField := 'segunda_feira';
  terca.DataField := 'terca_feira';
  quarta.DataField := 'quarta_feira';
  quinta.DataField := 'quinta_feira';
  sexta.DataField := 'sexta_feira';
  sabado.DataField := 'sabado';
  domingo.DataField := 'domingo';
  funcionario_publico.DataField := 'funcionario_publico';
  reparticao.DataField := 'reparticao';
  codigo_motorista.DataField := 'codigo_motorista';
  nome_motorista.DataField := 'motorista';
  ativo.DataField := 'ativo';
  inicio_pagamento.DataField := 'data_inicio_pagamento';
  codigo_valor.DataField := 'codigo_valor';
  descricao_valor.DataField := 'descricao_valor';
  ida.DataField := 'ida';
  volta.DataField := 'volta';

  ColocaMascaraCampos;
  //coloca o focus em um objeto
  CampoPesquisa.ItemIndex := 0 ;
  CampoPesquisa.SetFocus;

end;

procedure TFrmCadastroEstudantes.ColocaMascaraCampos();
var
  j : integer;
begin
   for j:=0 to sqlmanipula.Fields.Count-1 do begin
     if (sqlmanipula.Fields.Fields[j].DataType = ftDate) then
      sqlmanipula.Fields.Fields[j].EditMask := '99/99/9999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cep')then
      sqlmanipula.Fields.Fields[j].EditMask := '99999-999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cgc') or (sqlmanipula.Fields.Fields[j].FullName = 'cnpj') then
      sqlmanipula.Fields.Fields[j].EditMask := '99.999.999.9999-99;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'telefone') or (sqlmanipula.Fields.Fields[j].FullName = 'fax') or (sqlmanipula.Fields.Fields[j].FullName = 'celular') then
      sqlmanipula.Fields.Fields[j].EditMask := '(99) 9999-9999;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'rg')then
      sqlmanipula.Fields.Fields[j].EditMask := '99.999.999-9;1; ';
     if (sqlmanipula.Fields.Fields[j].FullName = 'cic') or (sqlmanipula.Fields.Fields[j].FullName = 'cpf') then
      sqlmanipula.Fields.Fields[j].EditMask := '999.999.9999-9;1; ';
   end;
end;

procedure TFrmCadastroEstudantes.DBGridTitleClick(Column: TColumn);
begin
  Ordenar_Select(Column.FieldName);
end;

procedure TFrmCadastroEstudantes.pesquisarClick(Sender: TObject);
var
  aRetorno : string;
begin
  if not validadados(chavepesquisa.Text) then begin
    application.MessageBox('Dados Para Pesquisa No So Vlidos !','Aviso',mb_iconexclamation);
    chavepesquisa.SetFocus;
    exit;
  end else if trim(chavepesquisa.Text) = '' then begin
    application.MessageBox('Preencha O Que Vai Ser Pesquisado !','Aviso',mb_iconexclamation);
    chavepesquisa.SetFocus;
    exit;
  end;

  aRetorno := RetornaTipoCampo(colocaunderline(primeiraletraminuscula(CampoPesquisa.Text)));
  SQLManipula.Close;
  SQLManipula.SQL.Clear;
  if aRetorno = 'INTEIRO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsInteger := strToInt(TiraPonto(ChavePesquisa.text)) ;
  end else if aRetorno = 'NUMERO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsString := trim(ChavePesquisa.text);
  end else if aRetorno = 'TEXTO' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' like :nValor ');
    SQLManipula.ParamByName('nValor').AsString := ChavePesquisa.text + '%' ;
  end else if aRetorno = 'DATA' then begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + colocaunderline(primeiraletraminuscula(campopesquisa.Text)) + ' = :nValor ');
    SQLManipula.ParamByName('nValor').AsDate := strToDate(ChavePesquisa.text);
  end else begin
    SQLManipula.SQL.Add('SELECT * FROM ' + TabelaReferencial + ' WHERE ' + CampoReferencial + ' IS NULL');
  end;
  SQLManipula.Open;
  ColocaMascaraCampos();
  ChavePesquisa.SetFocus;
  ChavePesquisa.SelectAll;
end;

procedure TFrmCadastroEstudantes.DBGridDblClick(Sender: TObject);
begin
  Pagecontrol.TabIndex := 1 ;
end;

procedure TFrmCadastroEstudantes.incluirClick(Sender: TObject);
begin
  SQLManipula.Append;
  sqlManipula.FieldByName('ativo').AsString := 'S' ;
  sqlManipula.FieldByName('cep').AsString := '14770-000' ;
  sqlManipula.FieldByName('estado').AsString := 'SP' ;
  sqlManipula.FieldByName('todos_dias').AsBoolean := true ;
  sqlManipula.FieldByName('segunda_feira').AsBoolean := false ;
  sqlManipula.FieldByName('terca_feira').AsBoolean := false ;
  sqlManipula.FieldByName('quarta_feira').AsBoolean := false ;
  sqlManipula.FieldByName('quinta_feira').AsBoolean := false ;
  sqlManipula.FieldByName('sexta_feira').AsBoolean := false ;
  sqlManipula.FieldByName('sabado').AsBoolean := false ;
  sqlManipula.FieldByName('domingo').AsBoolean := false ;
  sqlManipula.FieldByName('ida').AsBoolean := true ;
  sqlManipula.FieldByName('volta').AsBoolean := true ;
  sqlManipula.FieldByName('funcionario_publico').AsBoolean := false ;
  HabilitaBotoes(2);
  habilitaDiasSemana;
  habilitaFuncPublico;
  nome.SetFocus;
end;

procedure TFrmCadastroEstudantes.alterarClick(Sender: TObject);
begin
  if not sqlManipula.FieldByName(camporeferencial).IsNull then begin
    sqlmanipula.Edit;
    nFlagAlterar := true;
    HabilitaBotoes(2);
    habilitaDiasSemana;
    habilitaFuncPublico;
    nome.SetFocus;
  end else begin
    alerta('Nenhum Registro Selecionado Para Alterao !');
  end;
end;

procedure TFrmCadastroEstudantes.excluirClick(Sender: TObject);
begin
  if not sqlManipula.FieldByName(camporeferencial).IsNull then
    sqlmanipula.delete
  else begin
    alerta('Nenhum Registro Selecionado Para Excluso !');
    exit ;
  end;
  SQLmanipula.Refresh;
end;

procedure TFrmCadastroEstudantes.salvarClick(Sender: TObject);
begin
  //////////valida as informaoes antes de salvar
  if trim(codigo_valor.Text)='' then
   begin
    alerta('Cdigo de valor invalido !');
    codigo_valor.SetFocus;
    exit;
   end;

  if (not ida.Checked) and (not volta.Checked) then
   begin
    alerta('Marque pelo menos uma opo !!');
    ida.SetFocus;
    exit;
   end;

  sqlmanipula.Post;
  sqlmanipula.ApplyUpdates;
  nFlagAlterar := false;
  HabilitaBotoes(1);
  habilitaDiasSemana;
  habilitaFuncPublico;
end;

procedure TFrmCadastroEstudantes.abandonarClick(Sender: TObject);
begin
  SQLManipula.Cancel;
  SQLManipula.CancelUpdates;
  HabilitaBotoes(1);
  nFlagAlterar := false;  
end;

procedure TFrmCadastroEstudantes.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TFrmCadastroEstudantes.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if (key = #13) then begin
    Key := #0;
    SelectNext(activeControl,true,true);
  end;
end;

procedure TFrmCadastroEstudantes.HabilitaBotoes(aOpcao:integer);
begin
  ColocaMascaraCampos();
  incluir.Enabled := not(incluir.Enabled);
  alterar.Enabled := not(alterar.Enabled);
  excluir.Enabled := not(excluir.Enabled);
  salvar.Enabled := not(salvar.Enabled);
  abandonar.Enabled := not(abandonar.Enabled);

  pesquisa_escola.Enabled := not(pesquisa_escola.Enabled);
  pesquisa_curso.Enabled := not(pesquisa_curso.Enabled);
  pesquisa_motorista.Enabled := not(pesquisa_motorista.Enabled);
  pesquisa_valor.Enabled := not(pesquisa_valor.Enabled);
end;

procedure TFrmCadastroEstudantes.Ordenar_Select(OS_Campo: String);
var
  Temp1: Boolean;
  Temp3: Integer;
  Reg : Variant;
begin
  Reg := SQLManipula.FieldByName(CampoReferencial).AsVariant;
  Temp1:=True;
  for Temp3:=0 to SQLManipula.SQL.Count-1 do if Pos('order',LowerCase(SQLManipula.SQL.Strings[Temp3]))>0 then begin
    Temp1:=False;
    SQLManipula.SQL.Strings[Temp3]:='order by '+OS_Campo;
  end;
  if Temp1 then SQLManipula.SQL.Add('order by '+OS_Campo);
  SQLManipula.Close;
  SQLManipula.open;
  SQLManipula.Locate(CampoReferencial, Reg, [loCaseInsensitive]); 
end;

procedure TFrmCadastroEstudantes.PageControlChanging(Sender: TObject; var AllowChange: Boolean);
begin
  AllowChange := incluir.Enabled;
end;

procedure TFrmCadastroEstudantes.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //se for pressionado ESC
  if (key = vk_escape ) then begin
    //fecha o Form
    close;
  end;
end;

procedure TFrmCadastroEstudantes.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if salvar.Enabled then begin
    alerta('No Foi Possvel Executar A Operao Pois Existe'+chr(13)+chr(10)+'Uma Incluso Ou Alterao Est Em Andamento !');
    canclose := false;
  end;
end;

function TFrmCadastroEstudantes.ValidaDados(aValor: String):boolean;
var
  aRetorno : String;
  i : integer;
begin
  aRetorno := RetornaTipoCampo(colocaunderline(primeiraletraminuscula(CampoPesquisa.Text)));
  for i :=1 to length(trim(Avalor)) do begin
    if aRetorno = 'NUMERO' then begin // caso o tipo do campo seja um numero
      if not(aValor[i] in['0'..'9',#8,'.']) then begin
        result := false;
        exit;
      end;
    end else if aRetorno = 'INTEIRO' then begin // caso o tipo do campo seja um numero INTEIRO
      if not(aValor[i] in['0'..'9',#8]) then begin
        result := false;
        exit;
      end;
    end else if aRetorno = 'DATA' then begin // caso o tipo do campo seja um numero
      if not (ValidarData(aValor)) then begin
        result := false;
        exit;
      end;
    end;
  end;
  result := true;
end;

function TFrmCadastroEstudantes.RetornaTipoCampo(NomeCampo : String): String;
var
  aux : TFieldType;
begin
  aux := SQLManipula.FieldDefs.Items[SQLManipula.FieldDefs.IndexOf(NomeCampo)].DataType;
  if (aux=ftFloat) or (aux=ftCurrency) or (aux=ftFMTBcd) or (aux=ftLargeint) then
    RetornaTipoCampo := 'NUMERO'
  else if (aux=ftSmallint) or (aux=ftInteger) or (aux=ftWord) or (aux=ftAutoInc) then
    RetornaTipoCampo := 'INTEIRO'
  else if (aux=ftString) or (aux=ftFixedChar) or (aux=ftWideString) then
    RetornaTipoCampo := 'TEXTO'
  else if (aux=ftDate) or (aux=ftTime) or (aux=ftDateTime) or (aux=ftTimeStamp) then
    RetornaTipoCampo := 'DATA'
  else
    RetornaTipoCampo := 'DESCONHECIDO';
end;

procedure TFrmCadastroEstudantes.FormDestroy(Sender: TObject);
begin
  FrmCadastroEstudantes := nil;
end;

procedure TFrmCadastroEstudantes.Codigo_escolaExit(Sender: TObject);
var
  pesq : TZQuery ;
begin
   if trim(codigo_escola.Text)='' then
    begin
     nome_escola.Field.Clear;
     exit;
    end;
   pesq := TZQuery.Create(nil);
   pesq.Connection := bancodados.Conexao;
   pesq.SQL.Clear;
   pesq.SQL.Add('select nome from escolas where codigo = :nCod');
   pesq.ParamByName('nCod').AsInteger := codigo_escola.Field.AsInteger;
   pesq.Open;
   if pesq.RecordCount = 0 then
    begin
     alerta('Escola no cadastrada !');
     codigo_escola.Field.Clear;
     nome_escola.Field.Clear;
     codigo_escola.SetFocus;
     pesq.Close;
     pesq.Free;
     exit;
    end;
   nome_escola.Field.AsString := pesq.fieldByName('nome').AsString;
   pesq.Close;
   pesq.Free;
end;

procedure TFrmCadastroEstudantes.codigo_cursoExit(Sender: TObject);
var
  pesq : TZQuery ;
begin
   if trim(codigo_escola.Text)='' then
    begin
     nome_curso.Field.Clear;
     exit;
    end;
   pesq := TZQuery.Create(nil);
   pesq.Connection := bancodados.Conexao;
   pesq.SQL.Clear;
   pesq.SQL.Add('select nome from cursos where codigo = :nCod');
   pesq.ParamByName('nCod').AsInteger := codigo_curso.Field.AsInteger;
   pesq.Open;
   if pesq.RecordCount = 0 then
    begin
     alerta('Curso no cadastrado !');
     codigo_curso.Field.Clear;
     nome_curso.Field.Clear;
     codigo_curso.SetFocus;
     pesq.Close;
     pesq.Free;
     exit;
    end;
   nome_curso.Field.AsString := pesq.fieldByName('nome').AsString;
   pesq.Close;
   pesq.Free;
end;

procedure TFrmCadastroEstudantes.codigo_motoristaExit(Sender: TObject);
var
  pesq : TZQuery ;
begin
   if trim(codigo_motorista.Text)='' then
    begin
     nome_motorista.Field.Clear;
     exit;
    end;
   pesq := TZQuery.Create(nil);
   pesq.Connection := bancodados.Conexao;
   pesq.SQL.Clear;
   pesq.SQL.Add('select nome from motoristas where codigo = :nCod');
   pesq.ParamByName('nCod').AsInteger := codigo_motorista.Field.AsInteger;
   pesq.Open;
   if pesq.RecordCount = 0 then
    begin
     alerta('Motorista no cadastrado !');
     codigo_motorista.Field.Clear;
     nome_motorista.Field.Clear;
     codigo_motorista.SetFocus;
     pesq.Close;
     pesq.Free;
     exit;
    end;
   nome_motorista.Field.AsString := pesq.fieldByName('nome').AsString;
   pesq.Close;
   pesq.Free;
end;

procedure TFrmCadastroEstudantes.Pesquisa_escolaClick(Sender: TObject);
var
  pesq : TFrmPesquisaSimples ;
begin
  pesq := TFrmPesquisaSimples.Create(nil);
  pesq.TabelaReferencial := 'escolas';
  pesq.CampoReferencial := 'nome';
  pesq.ShowModal ;
  if (pesq.Confirma) and (not pesq.Tabela.fieldByname('codigo').IsNull) then begin
    codigo_escola.Field.AsInteger := pesq.Tabela.fieldByname('codigo').AsInteger;
    nome_escola.Field.AsString := pesq.Tabela.fieldByname('nome').AsString;
  end;
  pesq.Free;
end;

procedure TFrmCadastroEstudantes.Pesquisa_cursoClick(Sender: TObject);
var
  pesq : TFrmPesquisaSimples ;
begin
  pesq := TFrmPesquisaSimples.Create(nil);
  pesq.TabelaReferencial := 'cursos';
  pesq.CampoReferencial := 'nome';
  pesq.ShowModal ;
  if pesq.Confirma then
   begin
    codigo_curso.Field.AsInteger := pesq.Tabela.fieldByname('codigo').AsInteger;
    nome_curso.Field.AsString := pesq.Tabela.fieldByname('nome').AsString;
   end;
  pesq.Free;
end;

procedure TFrmCadastroEstudantes.Pesquisa_motoristaClick(Sender: TObject);
var
  pesq : TFrmPesquisaSimples ;
begin
  pesq := TFrmPesquisaSimples.Create(nil);
  pesq.TabelaReferencial := 'motoristas';
  pesq.CampoReferencial := 'nome';
  pesq.ShowModal ;
  if pesq.Confirma then
   begin
    codigo_motorista.Field.AsInteger := pesq.Tabela.fieldByname('codigo').AsInteger;
    nome_motorista.Field.AsString := pesq.Tabela.fieldByname('nome').AsString;
   end;
  pesq.Free;
end;

procedure TFrmCadastroEstudantes.valor_passeKeyPress(Sender: TObject;
  var Key: Char);
var
  x : integer;
begin
  //se for pressionado trao ( sinal de menos )
  if key = #45 then begin
    if TEdit(Sender).SelStart > 0 then begin
      key := #0
    end else begin
      if Length(TEdit(Sender).Text) > 0 then begin
        for x := 0 to length(TEdit(Sender).Text) do begin
          if Copy(TEdit(Sender).Text, x, 1) = '-' then begin
            key := #0;
            break;
          end;
        end;
      end;
    end;
  //se for pressionado ponto ou virgula
  end else if (key = #44) or (key = #46) then begin
    if ValidaQuebrado(TEdit(Sender)) then begin
      key := #44;
    end else begin
      key := #0;
    end;
  end else if not(Key in['0'..'9', #8]) then begin
    Key := #0;
  end;
end;

procedure TFrmCadastroEstudantes.Codigo_escolaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in['0'..'9',#8]) then begin
    key := #0;
  end;
end;

procedure TFrmCadastroEstudantes.codigo_cursoKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in['0'..'9',#8]) then begin
    key := #0;
  end;
end;

procedure TFrmCadastroEstudantes.codigo_motoristaKeyPress(Sender: TObject;
  var Key: Char);
begin
  if not (key in['0'..'9',#8]) then begin
    key := #0;
  end;
end;

procedure TFrmCadastroEstudantes.todos_diasClick(Sender: TObject);
begin
 if salvar.Enabled then
  begin
   habilitaDiasSemana;
  end;
end;

procedure TFrmCadastroEstudantes.habilitaDiasSemana;
begin
 if todos_dias.Checked then
   begin
    groupSenama.Enabled := false ;
   end else begin
    groupSenama.Enabled := true ;
   end;
end;

procedure TFrmCadastroEstudantes.habilitaFuncPublico;
begin
 if funcionario_publico.Checked then
  begin
    reparticao.Enabled := true ;
  end else begin
    reparticao.Enabled := false ;
    if SqlManipula.Modified then
     begin
      reparticao.Field.Clear;
     end;
  end;
end;

procedure TFrmCadastroEstudantes.funcionario_publicoClick(Sender: TObject);
begin
  habilitaFuncPublico;
end;

procedure TFrmCadastroEstudantes.pesquisa_valorClick(Sender: TObject);
var
  pesq : TFrmPesquisaSimples ;
begin
  pesq := TFrmPesquisaSimples.Create(nil);
  pesq.TabelaReferencial := 'valor_guia';
  pesq.CampoReferencial := 'descricao';
  pesq.strCampos := 'pk, descricao';
  pesq.ShowModal ;
  if pesq.Confirma then
   begin
    codigo_valor.Field.AsInteger := pesq.Tabela.fieldByname('pk').AsInteger;
    descricao_valor.Field.AsString := pesq.Tabela.fieldByname('descricao').AsString;
   end;
  pesq.Free;
end;

procedure TFrmCadastroEstudantes.codigo_valorExit(Sender: TObject);
var
  pesq : TZQuery ;
begin
   if trim(codigo_valor.Text)='' then
    begin
     descricao_valor.Field.Clear;
     exit;
    end;
   pesq := TZQuery.Create(nil);
   try
    pesq.Connection := bancodados.Conexao;
    pesq.SQL.Clear;
    pesq.SQL.Add('select descricao from valor_guia where pk = :nCod');
    pesq.ParamByName('nCod').AsInteger := codigo_valor.Field.AsInteger;
    pesq.Open;
    if pesq.RecordCount = 0 then
     begin
      alerta('Valor no cadastrado !');
      codigo_valor.Field.Clear;
      descricao_valor.Field.Clear;
      codigo_valor.SetFocus;
      exit;
     end;
    descricao_valor.Field.AsString := pesq.fieldByName('descricao').AsString;
   finally
    pesq.Close;
    pesq.Free;
   end;
end;

end.
